--[[
	Copyright (C) Udorn (Blackhand)
--]]

local viewType = "Spacer"
local version = 1
local YakaGui = LibStub("YakaGui", true)
local info = YakaGui:GetViewInfo(viewType) 
if (info and info.version >= version) then 
	return 
end

yaka = yaka or {}
yaka.Spacer = {}
yaka.Spacer.prototype = {}
yaka.Spacer.metatable = {__index = yaka.Spacer.prototype}
setmetatable(yaka.Spacer.prototype, {__index = yaka.View.prototype})

yaka.Spacer.info = {viewType = viewType, version = version}
yaka.Spacer.GetViewInfo = function()
	return yaka.Spacer.info
end

--[[ 
	Creates a new instance.
--]]
function yaka.Spacer:new(cfgIn)
	local instance = setmetatable({}, self.metatable)
	instance:InitCfg(cfgIn)
	instance:InitFrame()
	return instance
end

function yaka.Spacer.prototype:InitFrame()
	local frame = CreateFrame("Frame", nil, UIParent)
	frame.view = self
	self.frame = frame
	yaka.View.prototype.InitFrame(self)
end

-- register view

YakaGui:RegisterViewType(yaka.Spacer)