-- 																		Explaination 
-- 														How to create your own custom sound pack
--													-----------------------------------------------
--
--	local color = "|cff0066ff"	-- Place the color of the title text (e.g. "Sound Pack 1.1 (Mortal Kombat)") here. 
--								-- (Format is rr gg bb, e.g. |cff0000ff = Blue, |cff00ff00 = Green, |cffff0000 = Red)
--	
--	PowerAuras_SoundPack<MainID>_<SubID>_SoundInfo = {	-- This is a unique array that stores the sound data, 
--														-- <MainID> can be a number between 1-20
--														-- (This is usually the number assosciated with the sound pack, i.e. Sound Pack 1 will use 1, Sound Pack 2 will use 2, etc...)
--														-- <SubID> can be a number between 1-10
--														-- (This is to create multiple categories in the sound pack, i.e. pack 1.1, 1.2, 1.3... or "Pinkie Pack", "Fluttershy Pack", "Dash Pack"...)
--		["Name"] = color .. "<NAME>",	-- The name of the pack, <NAME> can be whatever you choose (e.g. "Sound Pack 1.1 (Mortal Kombat)" or "Crazy Super Awesome Pack")
--		["Path"] = "<PATH>",	-- The path to the files stored in this pack, be sure to use "\\" instead of "\" and put a "\\" at the end
								-- e.g. "Interface\\AddOns\\PowerAuras_SoundPack1\\Sounds\\1\\"
--		{	-- This is ID #1 in the Array
--			["Name"] = "<FILENAME>",	-- This is the name that the user will see, FILENAME can be anything (e.g. "Animality", "Crazy Boop", "Dancing Bear 2")
--			["File"] = "<FILE>.ogg",	-- This is the file name that the computer will use (e.g. "Animality.ogg", "MyAwesomeSong.ogg", "72Bottles.mp3")
										-- (Note: You can only use .ogg and .mp3 files in WoW, I recommend .ogg files)
--		},
--		{	-- This is ID #2 in the Array
--			["Name"] = "<FILENAME>",
--			["File"] = "<FILE>.ogg",
--		},

local color = "|cffFF0080"	-- Light Purple

PowerAuras_SoundPack2_1_SoundInfo = {
	["Name"] = color .. "Applejack",
	["Path"] = "Interface\\AddOns\\PowerAuras_SoundPack2\\Sounds\\applejack\\",
	{
		["Name"] = "Bullride",
		["File"] = "ajbullride.mp3",
	},
	{
		["Name"] = "Munching + Burp",
		["File"] = "ajburp.mp3",
	},
	{
		["Name"] = "Is that a challenge?",
		["File"] = "ajchallenge.mp3",
	},
	{
		["Name"] = "Geronimo!",
		["File"] = "ajgeronimo.mp3",
	},
	{
		["Name"] = "Get my rope",
		["File"] = "ajgetrope.mp3",
	},
	{
		["Name"] = "Oh for pete sake",
		["File"] = "ajpetesake.mp3",
	},
	{
		["Name"] = "Have you spit your bit?",
		["File"] = "ajspitbit.mp3",
	},
	{
		["Name"] = "what in tarnation?",
		["File"] = "ajtarnation.mp3",
	},
	{
		["Name"] = "Soup's on everypony",
		["File"] = "ajsoupson.mp3",
	},
	{
		["Name"] = "Can bees squawk?",
		["File"] = "ajbeessquawk.mp3",
	},
	{
		["Name"] = "hold your horses",
		["File"] = "ajholdhorses.mp3",
	},
	{
		["Name"] = "You're welcome",
		["File"] = "ajyourwelcome.mp3",
	},
	{
		["Name"] = "What in the hay?",
		["File"] = "ajwhatinthehay.mp3",
	},
	{
		["Name"] = "Thats what all the fuss is about?",
		["File"] = "ajfuss.mp3",
	},
	{
		["Name"] = "I like helping the ponyfolks",
		["File"] = "ajhelpponyfolk.mp3",
	},
	{
		["Name"] = "Ah ponyfeathers!",
		["File"] = "ajponyfeathers.mp3",
	},
	{
		["Name"] = "Twenty stalks? Bean or cellery?",
		["File"] = "aj20stalks.mp3",
	},
	{
		["Name"] = "Whats he all saddlesore about?",
		["File"] = "ajsaddlesore.mp3",
	},
	{
		["Name"] = "See ya'll later",
		["File"] = "ajseeyalater.mp3",
	},
	{
		["Name"] = "hay!",
		["File"] = "ajhay.mp3",
	},
	{
		["Name"] = "Well ok then!",
		["File"] = "ajokthen.mp3",
	},
	{
		["Name"] = "Didn't see thatone coming",
		["File"] = "ajdidntseethatone.mp3",
	},
	{
		["Name"] = "How'd you do that?",
		["File"] = "ajhowdyoudothat.mp3",
	},
	{
		["Name"] = "Thats how we do it down here",
		["File"] = "ajthatshowedoit.mp3",
	},
	{
		["Name"] = "I'm just better",
		["File"] = "ajimjustbetter.mp3",
	},
	{
		["Name"] = "Simmer down sally",
		["File"] = "ajsimmerdown.mp3",
	},
	{
		["Name"] = "Chocolate milk",
		["File"] = "ajchocolatemilk.mp3",
	},
	{
		["Name"] = "Thats just stinkin thinkin",
		["File"] = "ajstinkinthinkin.mp3",
	},
	{
		["Name"] = "Exactly",
		["File"] = "ajexactly.mp3",
	},
	{
		["Name"] = "Zebra sense",
		["File"] = "ajzebrasense.mp3",
	},
	{
		["Name"] = "I think were getting off-topic",
		["File"] = "ajofftopic.mp3",
	},
	{
		["Name"] = "Where do I start?",
		["File"] = "ajwherestart.mp3",
	},
	{
		["Name"] = "This is not the Rainbow Dash show",
		["File"] = "ajnotrdshow.mp3",
	},
}

PowerAuras_SoundPack2_2_SoundInfo = {
	["Name"] = color .. "Rainbow Dash",
	["Path"] = "Interface\\AddOns\\PowerAuras_SoundPack2\\Sounds\\rainbow\\",
	{
		["Name"] = "Aww Yeah!",
		["File"] = "dashawyeah.mp3",
	},
	{
		["Name"] = "Dun dun dunnn",
		["File"] = "dashdundundun.mp3",
	},
	{
		["Name"] = "Dont say I didn't warn you",
		["File"] = "dashwarn.mp3",
	},
	{
		["Name"] = "Wanna do this the hard way?",
		["File"] = "hardwaydash.mp3",
	},
	{
		["Name"] = "Here we go!",
		["File"] = "herewegodash.mp3",
	},
	{
		["Name"] = "It needs to be about 20% cooler",
		["File"] = "coolerdash.mp3",
	},
	{
		["Name"] = "Friendly neighbourhood Rainbow Dash",
		["File"] = "friendlyneighbourdash.mp3",
	},
	{
		["Name"] = "Ok this is getting old",
		["File"] = "rdgettingold.mp3",
	},
	{
		["Name"] = "Another great feat of heroism",
		["File"] = "rdheroism.mp3",
	},
	{
		["Name"] = "Danger is my middle name",
		["File"] = "rdmiddlename.mp3",
	},
	{
		["Name"] = "Let me handle this",
		["File"] = "rdletmehandlethis.mp3",
	},
	{
		["Name"] = "Stand back",
		["File"] = "rdstandback.mp3",
	},
	{
		["Name"] = "I'm doomed",
		["File"] = "rddoomed.mp3",
	},
	{
		["Name"] = "That is awesome",
		["File"] = "rdawesome.mp3",
	},
	{
		["Name"] = "You think you got what it takes?",
		["File"] = "rdgotwhatittakes.mp3",
	},
	{
		["Name"] = "This Competition isn't for the weak",
		["File"] = "rdisntforweak.mp3",
	},
	{
		["Name"] = "Step up your game",
		["File"] = "rdstepup.mp3",
	},
	{
		["Name"] = "I'm the one whos suposed to win",
		["File"] = "rdimsuposedtowin.mp3",
	},
	{
		["Name"] = "Put em up",
		["File"] = "rdputemup.mp3",
	},
	{
		["Name"] = "C'mon lets go!",
		["File"] = "rdcmonletsgo.mp3",
	},
	{
		["Name"] = "I got a message for you!",
		["File"] = "rdmsgforyou.mp3",
	},
	{
		["Name"] = "Does this count?",
		["File"] = "rdcount.mp3",
	},
	{
		["Name"] = "I'm sure to win now",
		["File"] = "rdsuretowin.mp3",
	},
	{
		["Name"] = "Your good",
		["File"] = "rdyourgood.mp3",
	},
	{
		["Name"] = "Louder",
		["File"] = "rdlouder1.mp3",
	},
	{
		["Name"] = "Louder!",
		["File"] = "rdlouder2.mp3",
	},
	{
		["Name"] = "LOUDER!!",
		["File"] = "rdlouder3.mp3",
	},
	{
		["Name"] = "Best day ever!",
		["File"] = "rdbestdayever.mp3",
	},
	{
		["Name"] = "Alright!",
		["File"] = "rdalright.mp3",
	},
	{
		["Name"] = "Not. cool.",
		["File"] = "rdnotcool.mp3",
	},
	{
		["Name"] = "Ohh alright..",
		["File"] = "rdohalright.mp3",
	},
	{
		["Name"] = "I was busy.. napping",
		["File"] = "rdbusynapping.mp3",
	},
	{
		["Name"] = "time to take out the adorable trash",
		["File"] = "rdtakeouttrash.mp3",
	},
	{
		["Name"] = "Stretch out those legs",
		["File"] = "rdstretchlegs.mp3",
	},
	{
		["Name"] = "Ten seconds flat",
		["File"] = "rd10secflat.mp3",
	},
	{
		["Name"] = "Yes, it's all true",
		["File"] = "rdyesitsalltrue.mp3",
	},
	{
		["Name"] = "Magic smagic, Boo!",
		["File"] = "rdboo.mp3",
	},
	{
		["Name"] = "Are you a spy?",
		["File"] = "rdspy.mp3",
	},
	{
		["Name"] = "Omigosh omigosh omigosh",
		["File"] = "rdomgomg.mp3",
	},
	{
		["Name"] = "I love fun things",
		["File"] = "rdlovefun.mp3",
	},
	{
		["Name"] = "(Laughing)",
		["File"] = "rdlaugh.mp3",
	},
}

PowerAuras_SoundPack2_3_SoundInfo = {
	["Name"] = color .. "Fluttershy",
	["Path"] = "Interface\\AddOns\\PowerAuras_SoundPack2\\Sounds\\fluttershy\\",
	{
		["Name"] = "Come out!",
		["File"] = "fluttershycomeout.mp3",
	},
	{
		["Name"] = "How dare you",
		["File"] = "fluttershydare1.mp3",
	},
	{
		["Name"] = "How dare you!",
		["File"] = "flutterdare2.mp3",
	},
	{
		["Name"] = "You're going to LOVE ME!",
		["File"] = "fluttershyloveme.mp3",
	},
	{
		["Name"] = "Way to go..",
		["File"] = "fluttershywaytogo.mp3",
	},
	{
		["Name"] = "You rock",
		["File"] = "fluttershyyourock.mp3",
	},
	{
		["Name"] = "Ok I can do this",
		["File"] = "fluttericandothis.mp3",
	},
	{
		["Name"] = "Yay",
		["File"] = "fluttershyyay.ogg",
	},
	{
		["Name"] = "Yay2",
		["File"] = "fluttershyyay2.mp3",
	},
	{
		["Name"] = "Yay3",
		["File"] = "fluttershyyay3.mp3",
	},
	{
		["Name"] = "Am I interupting?",
		["File"] = "fluttershyinterupt.mp3",
	},
	{
		["Name"] = "Too quiet",
		["File"] = "fluttershytooquiet.mp3",
	},
	{
		["Name"] = "You're the cutest thing ever",
		["File"] = "fluttershycutestever.mp3",
	},
	{
		["Name"] = "So incredibly wonderfull",
		["File"] = "fluttershywonderfull.mp3",
	},
	{
		["Name"] = "Always works",
		["File"] = "fluttershyalwaysworks.mp3",
	},
	{
		["Name"] = "It's exactly what I wished for",
		["File"] = "fluttershywishedfor.mp3",
	},
	{
		["Name"] = "Huffy the magic dragon",
		["File"] = "fluttershyhuffy.mp3",
	},
	{
		["Name"] = "WAIT!",
		["File"] = "fluttershywait.mp3",
	},
	{
		["Name"] = "(grin)",
		["File"] = "fluttershygrin.mp3",
	},
	{
		["Name"] = "Maybe but but no",
		["File"] = "fluttershymaybebutno.mp3",
	},
	{
		["Name"] = "I'm the world champ you know",
		["File"] = "fluttershyworldchamp.mp3",
	},
	{
		["Name"] = "You'll be mine! MINE!",
		["File"] = "fluttershyyoulbemine.mp3",
	},
	{
		["Name"] = "I'll catch you yet my pretties",
		["File"] = "fluttershycatchyou.mp3",
	},
	{
		["Name"] = "I'm leaving now",
		["File"] = "fluttershyleaving.mp3",
	},
	{
		["Name"] = "You loudmouth",
		["File"] = "fluttershyloudmouth.mp3",
	},
	{
		["Name"] = "Here you go",
		["File"] = "fluttershyhereyougo.mp3",
	},
	{
		["Name"] = "He's a bear",
		["File"] = "fluttershybear.mp3",
	},
	{
		["Name"] = "NO!",
		["File"] = "fluttershyNO.mp3",
	},
	{
		["Name"] = "Did my cheering do that?",
		["File"] = "fluttershydidmycheeringdothat.mp3",
	},
	{
		["Name"] = "The magic",
		["File"] = "fluttershythemagic.mp3",
	},
	{
		["Name"] = "It's.. nice..",
		["File"] = "fluttershyitsnice.mp3",
	},
	{
		["Name"] = "Excuse me",
		["File"] = "fluttershyexcuseme.mp3",
	},
	{
		["Name"] = "(train)",
		["File"] = "fluttershytrain.mp3",
	},
	{
		["Name"] = "Awfull, just awfull",
		["File"] = "fluttershyawfull.mp3",
	},
	{
		["Name"] = "Good with animals and kids",
		["File"] = "fluttershygoodwithstuff.mp3",
	},
	{
		["Name"] = "I'd like to be a tree",
		["File"] = "fluttershytree.mp3",
	},
	{
		["Name"] = "You do not hurt my friends!",
		["File"] = "fluttershydonthurt.mp3",
	},
	{
		["Name"] = "Whatever you do is fine",
		["File"] = "fluttershywhateverisfine.mp3",
	},
	{
		["Name"] = "Dr. Fluttershy expected that",
		["File"] = "fluttershyexpected.mp3",
	},
	{
		["Name"] = "Aw boo hoo hoo!",
		["File"] = "fluttershyboohoo.mp3",
	},
	{
		["Name"] = "(panic)",
		["File"] = "fluttershypanic.mp3",
	},
	{
		["Name"] = "I am weak and helpless",
		["File"] = "fluttershyweak.mp3",
	},
	{
		["Name"] = "Your face!",
		["File"] = "fluttershyyourface.mp3",
	},
	{
		["Name"] = "Big dumb meanie!",
		["File"] = "fluttershybigmeanie.mp3",
	},
	{
		["Name"] = "Is it ok if I hold you down?",
		["File"] = "fluttershyagainstwill.mp3",
	},
	{
		["Name"] = "I vote for calm",
		["File"] = "fluttershyvotecalm.mp3",
	},
}

PowerAuras_SoundPack2_4_SoundInfo = {
	["Name"] = color .. "Twilight Sparkle",
	["Path"] = "Interface\\AddOns\\PowerAuras_SoundPack2\\Sounds\\twilight\\",
	{
		["Name"] = "Very smart",
		["File"] = "twilightverysmart.mp3",
	},
	{
		["Name"] = "It'l all be fine",
		["File"] = "twilightitsfine.mp3",
	},
	{
		["Name"] = "Come on big boy",
		["File"] = "twilightbigboy.mp3",
	},
	{
		["Name"] = "Dont worry everyone",
		["File"] = "twilightdontworry.mp3",
	},
	{
		["Name"] = "Fail safe failed",
		["File"] = "twilightfailsafefail.mp3",
	},
	{
		["Name"] = "Fight all you want",
		["File"] = "twilightfightallyouwant.mp3",
	},
	{
		["Name"] = "Stop giving him cake",
		["File"] = "twilightstopcake.mp3",
	},
	{
		["Name"] = "My whole life depends on it!",
		["File"] = "twilightdepends.mp3",
	},
	{
		["Name"] = "Enough is enough!",
		["File"] = "twilightenough.mp3",
	},
	{
		["Name"] = "No no no no this is bad",
		["File"] = "twilightnonobad.mp3",
	},
	{
		["Name"] = "Ok heres the plan",
		["File"] = "twilightherestheplan.mp3",
	},
	{
		["Name"] = "No excuses",
		["File"] = "twilightnoexcuses.mp3",
	},
	{
		["Name"] = "Maybe on second thought",
		["File"] = "twilightsecondthough.mp3",
	},
	{
		["Name"] = "Uhm.. yes",
		["File"] = "twilighthumyes.mp3",
	},
	{
		["Name"] = "Oow..kay..",
		["File"] = "twilightowk.mp3",
	},
	{
		["Name"] = "Yes yes yes yes yes yes",
		["File"] = "twilightyesyesyesyes.mp3",
	},
	{
		["Name"] = "Huh 1",
		["File"] = "twilighthuh1.mp3",
	},
	{
		["Name"] = "Huh 2",
		["File"] = "twilighthuh2.mp3",
	},
	{
		["Name"] = "Huh 3",
		["File"] = "twilighthuh3.mp3",
	},
	{
		["Name"] = "Prove it",
		["File"] = "twilightproveit.mp3",
	},
	{
		["Name"] = "Are you crazy?",
		["File"] = "twilightyoucrazy.mp3",
	},
	{
		["Name"] = "I dont get it",
		["File"] = "twilightdontgetit.mp3",
	},
	{
		["Name"] = "I dont follow",
		["File"] = "twilightdontfollow.mp3",
	},
	{
		["Name"] = "(pinkieswear)",
		["File"] = "twilightswear.mp3",
	},
	{
		["Name"] = "Doesn't that hurt?",
		["File"] = "twilighthurt.mp3",
	},
	{
		["Name"] = "Not this again",
		["File"] = "twilightnotthisagain.mp3",
	},
	{
		["Name"] = "Help! You need help!",
		["File"] = "twilighthelpyouneed.mp3",
	},
	{
		["Name"] = "This is serious business",
		["File"] = "twilightsrsbsns.mp3",
	},
	{
		["Name"] = "This cant be good",
		["File"] = "twilightcantbegood.mp3",
	},
	{
		["Name"] = "I'm ready",
		["File"] = "twilightready.mp3",
	},
	{
		["Name"] = "I've learned a new spell that'l fix everything",
		["File"] = "twilightnewspell.mp3",
	},
	{
		["Name"] = "For them! For me! For Equestria!",
		["File"] = "twilightforequestria.mp3",
	},
	{
		["Name"] = "Clock is ticking",
		["File"] = "twilightclock.mp3",
	},
	{
		["Name"] = "I'd hate to cause a rift",
		["File"] = "twilightcauserift.mp3",
	},
	{
		["Name"] = "No shrieking squeeling or screaming",
		["File"] = "twilightnoshrieking.mp3",
	},
	{
		["Name"] = "Tenacity",
		["File"] = "twilighttenacity.mp3",
	},
	{
		["Name"] = "It's so simple",
		["File"] = "twilightsimple.mp3",
	},
	{
		["Name"] = "So practical",
		["File"] = "twilightpractical.mp3",
	},
	{
		["Name"] = "No distractions",
		["File"] = "twilightnodistractions.mp3",
	},
}

PowerAuras_SoundPack2_5_SoundInfo = {
	["Name"] = color .. "Rarity",
	["Path"] = "Interface\\AddOns\\PowerAuras_SoundPack2\\Sounds\\rarity\\",
	{
		["Name"] = "Crime against fabulousity",
		["File"] = "raritycrime.mp3",
	},
	{
		["Name"] = "Afraid to get dirty?",
		["File"] = "raritydirty.mp3",
	},
	{
		["Name"] = "Try it punk!",
		["File"] = "raritytryitpunk.mp3",
	},
	{
		["Name"] = "I know where you live",
		["File"] = "raritylive.mp3",
	},
	{
		["Name"] = "Take that you ruffian!",
		["File"] = "raritytakethat.mp3",
	},
	{
		["Name"] = "It is on!",
		["File"] = "rarityitison.mp3",
	},
	{
		["Name"] = "It is on! 2",
		["File"] = "rarityitison2.mp3",
	},
	{
		["Name"] = "Be quiet NOW!",
		["File"] = "rarityquietnow.mp3",
	},
	{
		["Name"] = "Wahahaa",
		["File"] = "raritywahaha.mp3",
	},
	{
		["Name"] = "Gently please!",
		["File"] = "raritygentlyplease.mp3",
	},
	{
		["Name"] = "Oohoooh",
		["File"] = "rarityoohoooh.mp3",
	},
	{
		["Name"] = "Make it stop",
		["File"] = "raritymakeitstop.mp3",
	},
	{
		["Name"] = "How can you be so insensitive",
		["File"] = "rarityinsensitive.mp3",
	},
	{
		["Name"] = "Please please please",
		["File"] = "rarityplease.mp3",
	},
	{
		["Name"] = "I love it!",
		["File"] = "rarityiloveit.mp3",
	},
	{
		["Name"] = "Whatever shall we do",
		["File"] = "raritywhatevershallwedo.mp3",
	},
	{
		["Name"] = "Whatever shall we do 2",
		["File"] = "raritywhatevershallwedo2.mp3",
	},
	{
		["Name"] = "Some of us do have standards",
		["File"] = "raritystandards.mp3",
	},
	{
		["Name"] = "You must you must!",
		["File"] = "rarityyoumust.mp3",
	},
	{
		["Name"] = "Idea!",
		["File"] = "rarityidea.mp3",
	},
	{
		["Name"] = "My destiny!",
		["File"] = "raritydestiny.mp3",
	},
	{
		["Name"] = "Everypony for herself!",
		["File"] = "rarityforherself.mp3",
	},
	{
		["Name"] = "You are a royal pain!",
		["File"] = "rarityroyalpain.mp3",
	},
	{
		["Name"] = "Dumb rock",
		["File"] = "raritydumbrock.mp3",
	},
	{
		["Name"] = "I wont be spoken to that way",
		["File"] = "rarityprincess.mp3",
	},
	{
		["Name"] = "Watching you stoop down",
		["File"] = "raritystoopdown.mp3",
	},
	{
		["Name"] = "This is a crime against fashion",
		["File"] = "rarityfashioncrime.mp3",
	},
	{
		["Name"] = "The thing with the stuff",
		["File"] = "raritythingstuff.mp3",
	},
	{
		["Name"] = "I know what I need to do",
		["File"] = "rarityknowwhattodo.mp3",
	},
	{
		["Name"] = "It takes teamwork",
		["File"] = "rarityteamwork.mp3",
	},
	{
		["Name"] = "Why do you have to be so good",
		["File"] = "raritywhyugood.mp3",
	},
	{
		["Name"] = "The worst possible thing",
		["File"] = "rarityworstpossible.mp3",
	},
	{
		["Name"] = "Anything i can do",
		["File"] = "raritywetordirty.mp3",
	},
}

PowerAuras_SoundPack2_6_SoundInfo = {
	["Name"] = color .. "Pinkie Pie",
	["Path"] = "Interface\\AddOns\\PowerAuras_SoundPack2\\Sounds\\pinkie\\",
	{
		["Name"] = "And thats how Equestria was made",
		["File"] = "pinkieandthatshow.mp3",
	},
	{
		["Name"] = "Twitchy",
		["File"] = "pinkietwitch.mp3",
	},
	{
		["Name"] = "Twitchy 2",
		["File"] = "pinkietwitch2.mp3",
	},
	{
		["Name"] = "Asaulting with cake",
		["File"] = "pinkieassaultcake.mp3",
	},
	{
		["Name"] = "I call em combos",
		["File"] = "pinkiecombo.mp3",
	},
	{
		["Name"] = "hah hah hah",
		["File"] = "pinkiehahaha.mp3",
	},
	{
		["Name"] = "no no NO NO!",
		["File"] = "pinkienono.mp3",
	},
	{
		["Name"] = "Are you loco in the coco?",
		["File"] = "pinkieloco.mp3",
	},
	{
		["Name"] = "I'll save you!",
		["File"] = "pinkiesaveyou.mp3",
	},
	{
		["Name"] = "Pinkieswear",
		["File"] = "pinkieswear.mp3",
	},
	{
		["Name"] = "How dare you take the cake!?",
		["File"] = "pinkietakecake.mp3",
	},
	{
		["Name"] = "Auntie pinkie got it all taken care off",
		["File"] = "pinkietakencare.mp3",
	},
	{
		["Name"] = "Holy moly thats alotta holies",
		["File"] = "pinkielottaholies.mp3",
	},
	{
		["Name"] = "Watch out!",
		["File"] = "pinkiewatchout.mp3",
	},
	{
		["Name"] = "Can I have more of that mushy stuff?",
		["File"] = "pinkiemushystuff.mp3",
	},
	{
		["Name"] = "And I, got my eye on you",
		["File"] = "pinkieeyeonyou.mp3",
	},
	{
		["Name"] = "Sarsparilla!",
		["File"] = "pinkiesarsparilla.mp3",
	},
	{
		["Name"] = "Bats on my face!",
		["File"] = "pinkiebatsonface.mp3",
	},
	{
		["Name"] = "You'd be good at eating cupcakes",
		["File"] = "pinkieeatcupcakes.mp3",
	},
	{
		["Name"] = "I know your in there!",
		["File"] = "pinkieknowyourinthere.mp3",
	},
	{
		["Name"] = "I love something",
		["File"] = "pinkieilovesomething.mp3",
	},
	{
		["Name"] = "You're good",
		["File"] = "pinkieyourgood.mp3",
	},
	{
		["Name"] = "Boo!",
		["File"] = "pinkieboo.mp3",
	},
	{
		["Name"] = "Now do a backflip!",
		["File"] = "pinkiebackflip.mp3",
	},
	{
		["Name"] = "you know",
		["File"] = "pinkieyouknow.mp3",
	},
	{
		["Name"] = "I know how it goes alright",
		["File"] = "pinkieknowhowitgoes.mp3",
	},
	{
		["Name"] = "gotta go find a trombone",
		["File"] = "pinkietrombone.mp3",
	},
	{
		["Name"] = "Busy having fun",
		["File"] = "pinkiebusyfun.mp3",
	},
	{
		["Name"] = "Aha! I knew it!",
		["File"] = "pinkieknewit.mp3",
	},
	{
		["Name"] = "Ooooohhh",
		["File"] = "pinkieoooooh.mp3",
	},
	{
		["Name"] = "Okie dokie lokie 1",
		["File"] = "pinkieokidoki1.mp3",
	},
	{
		["Name"] = "Okie dokie lokie 2",
		["File"] = "pinkieokidoki2.mp3",
	},
	{
		["Name"] = "Okie dokie lokie 3",
		["File"] = "pinkieokidoki3.mp3",
	},
	{
		["Name"] = "Okie dokie lokie 4",
		["File"] = "pinkieokidoki4.mp3",
	},
	{
		["Name"] = "Okie dokie lokie 5",
		["File"] = "pinkieokidoki5.mp3",
	},
	{
		["Name"] = "This calls for a party!",
		["File"] = "pinkiecallsparty.mp3",
	},
	{
		["Name"] = "Shiny! Pretty! Fancy!",
		["File"] = "pinkieshiny.mp3",
	},
	{
		["Name"] = "Pies oh my",
		["File"] = "pinkiepiesohmy.mp3",
	},
	{
		["Name"] = "There's an alligator in the tub",
		["File"] = "pinkiealligator.mp3",
	},
	{
		["Name"] = "You've got a real problem",
		["File"] = "pinkierealproblem.mp3",
	},
	{
		["Name"] = "Something you never expected is gonna happen",
		["File"] = "pinkieneverexpect.mp3",
	},
	{
		["Name"] = "This calls for extreme measures",
		["File"] = "pinkieextreme.mp3",
	},
	{
		["Name"] = "Pinkie Pie style",
		["File"] = "pinkiepiestyle.mp3",
	},
	{
		["Name"] = "You better think before you laugh at the pink",
		["File"] = "pinkiethepink.mp3",
	},
	{
		["Name"] = "Well duh",
		["File"] = "pinkiewellduh.mp3",
	},
	{
		["Name"] = "I never leave home without my party cannon",
		["File"] = "pinkiepartycannon.mp3",
	},
	{
		["Name"] = "Shut up",
		["File"] = "pinkieshutup.mp3",
	},
}

PowerAuras_SoundPack2_7_SoundInfo = {
	["Name"] = color .. "Luna Celestia",
	["Path"] = "Interface\\AddOns\\PowerAuras_SoundPack2\\Sounds\\celestialuna\\",
	{
		["Name"] = "Luna - The fun has been doubled",
		["File"] = "Lunadoublefun.mp3",
	},
	{
		["Name"] = "Luna - BE STILL!",
		["File"] = "lunabestill.mp3",
	},
	{
		["Name"] = "Luna - Be that way",
		["File"] = "lunabethatway.mp3",
	},
	{
		["Name"] = "Luna - We command you",
		["File"] = "lunacommand.mp3",
	},
	{
		["Name"] = "Luna - FOREVER!",
		["File"] = "lunaforever.mp3",
	},
	{
		["Name"] = "Luna - Fun? what is this fun?",
		["File"] = "lunafun.mp3",
	},
	{
		["Name"] = "Luna - We could not be happier",
		["File"] = "lunahappier.mp3",
	},
	{
		["Name"] = "Luna - How about now",
		["File"] = "lunahowboutnow.mp3",
	},
	{
		["Name"] = "Luna - Huzzah",
		["File"] = "lunahuzzah.mp3",
	},
	{
		["Name"] = "Luna - Tis a lie",
		["File"] = "lunalie.mp3",
	},
	{
		["Name"] = "Luna - Make peace",
		["File"] = "lunapeace.mp3",
	},
	{
		["Name"] = "Luna - How many points do I revieve?",
		["File"] = "lunapoints.mp3",
	},
	{
		["Name"] = "Luna - What purpose do these serve?",
		["File"] = "lunapurpose.mp3",
	},
	{
		["Name"] = "Luna - Traditional ROYAL CANTERLOT VOICE",
		["File"] = "lunaroyalvoice.mp3",
	},
	{
		["Name"] = "Luna - Thou backside is whole and ungobbled",
		["File"] = "lunaungobbled.mp3",
	},
	{
		["Name"] = "Luna - Very well then",
		["File"] = "lunaverywell.mp3",
	},
	{
		["Name"] = "Luna - What is the matter with you",
		["File"] = "lunawhatisthematter.mp3",
	},
	{
		["Name"] = "Luna - Forgive me if I withold my entheusiasm",
		["File"] = "lunawithhold.mp3",
	},
	{
		["Name"] = "Luna - Oh most wonderfull of nights",
		["File"] = "lunawonderfullnight.mp3",
	},
	{
		["Name"] = "Celestia - A very valuable lesson",
		["File"] = "celesitalesslonlearned.mp3",
	},
	{
		["Name"] = "Celestia - Good luck my little ponies",
		["File"] = "celestiagoodluck.mp3",
	},
	{
		["Name"] = "Celestia - Gotcha",
		["File"] = "celestiagotcha.mp3",
	},
	{
		["Name"] = "Celestia - Rather melodramatic if you ask me",
		["File"] = "celestiamelodramatic.mp3",
	},
	{
		["Name"] = "Celestia - This doesn't make sence",
		["File"] = "celestianosence.mp3",
	},
	{
		["Name"] = "Celestia - I'm so proud of you",
		["File"] = "celestiaproud.mp3",
	},
}

PowerAuras_SoundPack2_8_SoundInfo = {
	["Name"] = color .. "CMC",
	["Path"] = "Interface\\AddOns\\PowerAuras_SoundPack2\\Sounds\\cmc\\",
	{
		["Name"] = "Applebloom - that'l be four bits",
		["File"] = "applebloombits.mp3",
	},
	{
		["Name"] = "Applebloom - (burps)",
		["File"] = "applebloomburp.mp3",
	},
	{
		["Name"] = "Applebloom - You're just chicken",
		["File"] = "applebloomchicken.mp3",
	},
	{
		["Name"] = "Applebloom - Cool",
		["File"] = "applebloomcool.mp3",
	},
	{
		["Name"] = "Applebloom - Whatcha got going on there?",
		["File"] = "applebloomgoinonthere.mp3",
	},
	{
		["Name"] = "Applebloom - Likely story",
		["File"] = "applebloomlikely.mp3",
	},
	{
		["Name"] = "Applebloom - Put this thing out of its missery",
		["File"] = "applebloommissery.mp3",
	},
	{
		["Name"] = "Applebloom - Trust me",
		["File"] = "applebloomtrustme.mp3",
	},
	{
		["Name"] = "Scootaloo - I'm liking this idea",
		["File"] = "scootliking.mp3",
	},
	{
		["Name"] = "Scootaloo - Chaos",
		["File"] = "scootaloochaos.mp3",
	},
	{
		["Name"] = "Scootaloo - Did you just come up with that now?",
		["File"] = "scootaloocomeup.mp3",
	},
	{
		["Name"] = "Scootaloo - Possibilities are.. like endless",
		["File"] = "scootalooendless.mp3",
	},
	{
		["Name"] = "Scootaloo - Never never never!",
		["File"] = "scootaloonever.mp3",
	},
	{
		["Name"] = "Scootaloo - Wha..huh?",
		["File"] = "scootaloowhahuh.mp3",
	},
	{
		["Name"] = "Scootaloo - Why not..",
		["File"] = "scootaloowhynot.mp3",
	},
	{
		["Name"] = "Scootaloo - What are you doing?",
		["File"] = "scootaloowutudoing.mp3",
	},
	{
		["Name"] = "Sweetie Belle - You cannot run from me",
		["File"] = "sbellerun.mp3",
	},
	{
		["Name"] = "sweetie Belle - NO!",
		["File"] = "sbno.mp3",
	},
	{
		["Name"] = "sweetie Belle - Plan B?",
		["File"] = "sbplanb.mp3",
	},
	{
		["Name"] = "sweetie Belle - Sounds serious",
		["File"] = "sbsoundsserious.mp3",
	},
	{
		["Name"] = "sweetie Belle - Sure we can",
		["File"] = "sbsurewecan.mp3",
	},
	{
		["Name"] = "sweetie Belle - Was it that bad?",
		["File"] = "sbthatbad.mp3",
	},
	{
		["Name"] = "sweetie Belle - Tiger taming",
		["File"] = "sbtiger.mp3",
	},
	{
		["Name"] = "sweetie Belle - Wooo.. I mean yay",
		["File"] = "sbwooimeanyay.mp3",
	},
}

PowerAuras_SoundPack2_9_SoundInfo = {
	["Name"] = color .. "Spike",
	["Path"] = "Interface\\AddOns\\PowerAuras_SoundPack2\\Sounds\\spike\\",
	{
		["Name"] = "There is no pain that would keep me from assisting",
		["File"] = "spikenopain.mp3",
	},
	{
		["Name"] = "Thick scales, can't feel a thing",
		["File"] = "spikethickscales.mp3",
	},
	{
		["Name"] = "Haha! you did it",
		["File"] = "spikeyoudidit.mp3",
	},
	{
		["Name"] = "Can I have that globe?",
		["File"] = "spikehasglobe.mp3",
	},
	{
		["Name"] = "Who else has a present for Spikeywikey?",
		["File"] = "spikeywikey.mp3",
	},
	{
		["Name"] = "Gosh, you really like it huh",
		["File"] = "spikelikeit.mp3",
	},
	{
		["Name"] = "Way to go little guy",
		["File"] = "spikewaytogo.mp3",
	},
	{
		["Name"] = "Cupcakes",
		["File"] = "spikecupcakes.mp3",
	},
	{
		["Name"] = "Ready",
		["File"] = "spikeready.mp3",
	},
	{
		["Name"] = "Snap out of it!",
		["File"] = "spikesnapoutofit.mp3",
	},
	{
		["Name"] = "Looking good spike",
		["File"] = "spikelookgood.mp3",
	},
	{
		["Name"] = "I have no idea",
		["File"] = "spikenoidea.mp3",
	},
	{
		["Name"] = "A natural disaster",
		["File"] = "spikenaturaldisaster.mp3",
	},
	{
		["Name"] = "Whatever",
		["File"] = "spikewhatever.mp3",
	},
	{
		["Name"] = "Awkward",
		["File"] = "spikeakward.mp3",
	},
	{
		["Name"] = "(Evil Laugh)",
		["File"] = "spikeevillaugh.mp3",
	},
}

PowerAuras_SoundPack2_10_SoundInfo = {
	["Name"] = color .. "Others",
	["Path"] = "Interface\\AddOns\\PowerAuras_SoundPack2\\Sounds\\other\\",
	{
		["Name"] = "Discord - Oh for goodness sake!",
		["File"] = "discordffs.mp3",
	},
	{
		["Name"] = "Discord - Looks on your faces",
		["File"] = "discordpriceless.mp3",
	},
	{
		["Name"] = "Discord - Games over",
		["File"] = "discordgameover.mp3",
	},
	{
		["Name"] = "Discord - Arriverderci",
		["File"] = "discordarriverderci.mp3",
	},
	{
		["Name"] = "Discord - I have some chaos to wreak",
		["File"] = "discordchaos.mp3",
	},
	{
		["Name"] = "Discord - Good luck everypony",
		["File"] = "discordgoodluck.mp3",
	},
	{
		["Name"] = "Discord - Hello",
		["File"] = "discordhello.mp3",
	},
	{
		["Name"] = "Discord - I know much more then that",
		["File"] = "discordknowmore.mp3",
	},
	{
		["Name"] = "Discord - Maybe the magic of friendship can help",
		["File"] = "discordmagic.mp3",
	},
	{
		["Name"] = "Discord - Just make it quick",
		["File"] = "discordmakeitquick.mp3",
	},
	{
		["Name"] = "Discord - What fun is there in making sence",
		["File"] = "discordmakesence.mp3",
	},
	{
		["Name"] = "Junebug - uh, no problem",
		["File"] = "junebugnoproblem.mp3",
	},
	{
		["Name"] = "Junebug - I dont have anything",
		["File"] = "junebugdonthave.mp3",
	},
	{
		["Name"] = "Cheerilee - I wish I had something to give you",
		["File"] = "cheerileegive.mp3",
	},
	{
		["Name"] = "Trixie - It's true my entheusiastic little admirers",
		["File"] = "trixieadmirers.mp3",
	},
	{
		["Name"] = "Trixie - Anything you can do, I can do better",
		["File"] = "trixieicandobetter.mp3",
	},
	{
		["Name"] = "Trixie - It seems we have some neighsayers",
		["File"] = "trixieneighsayers.mp3",
	},
	{
		["Name"] = "Trixie - Show us all",
		["File"] = "trixieshowusall.mp3",
	},
	{
		["Name"] = "Zecora - Beware",
		["File"] = "zecorabeware.mp3",
	},
	{
		["Name"] = "Zecora - Your actions will make my anger explode",
		["File"] = "zecoraexplode.mp3",
	},
	{
		["Name"] = "Zecora - How dare you",
		["File"] = "zecorahowdareu.mp3",
	},
	{
		["Name"] = "Zecora - Have you gone mad?",
		["File"] = "zecoraumad.mp3",
	},
	{
		["Name"] = "Zecora - Your doomed",
		["File"] = "zecorayourdoomed.mp3",
	},
}
