/**
 * EpicMusicPlayer Playlistgenerator
 *
 * @author yess
 *
 * This is not a good example how to write a java application. 
 * But hey its working^^
 *
 */

package app;

import gui.*;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.nio.channels.FileChannel;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.FileHandler;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.logging.SimpleFormatter;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import org.jdesktop.application.Application;
import org.jdesktop.application.SingleFrameApplication;

/**
 * The main class of the application.
 */
public class EMPApp extends SingleFrameApplication {

    private Config conf;
    private int admin;
    private String configFile = "emp.config";
    private String parameter = "";
    private String wowdir = null;
   
    @Override
    protected void initialize(String[] args) {
        for(int i=0;i < args.length;i++){
            String para = args[i]; 
            if (para.contains("admin=")) {
                para = para.replaceFirst("admin=","");
                admin = Integer.valueOf(para).intValue();
            }

            if (para.contains("wowdir=")) {
                wowdir = para.replaceFirst("wowdir=","");
            }
        }
    }

     
    /**
     * At startup create and show the main frame of the application.
     */
    @Override protected void startup(){
        
        System.out.println("admin="+admin);
        Logger.getLogger("epicmusicplayer").log(Level.FINEST,"OS: "+System.getProperty("os.version")+" Java version:"+System.getProperty("java.version")+" Java name:"+System.getProperty("java.vm.name"));

        //++++++++++++  get wowDir +++++++++++++++
        try{
            conf = new Config(configFile);
        } catch (RegistryException e) {
            //could not get wow folder from registry
            Logger.getLogger("epicmusicplayer").log(Level.SEVERE,e.getMessage(),e);
            selectWoWFolder();
        } catch (Exception e1) {
            // quick fix
            if (new File(configFile).exists())
            {
                //could not get wow folder from configFile
                Logger.getLogger("epicmusicplayer").log(Level.SEVERE,e1.getMessage(),e1);
                Logger.getLogger("epicmusicplayer").log(Level.SEVERE,"Error loading config. Please delete the emp.config");
                myExit("Error loading config. Please delete the emp.config");
            }
            else
            {
                selectWoWFolder();
            }
        }

        //+++++++++ check write access to wow folder ++++++++++++
        //SecurityManager manager = new SecurityManager();
        String path = conf.getWoWDir().getPath();

        String test= "can write to: "+path+" ="+checkWrite(path);
        Logger.getLogger("epicmusicplayer").log(Level.FINE, test);

        String apppath = getAppPath();
        Logger.getLogger("epicmusicplayer").log(Level.FINE, "exe path: "+apppath);


        System.out.println("can write to: "+path+ " ="+checkWrite(path));
        if(admin==0 && !checkWrite(path)){
           try {
                if (System.getProperty("java.vm.name").contains("64-Bit"))
                {
                    //runAsAdmin will not fail to load the dll on java 64bit
                    String message = "Cant write to: "+conf.getWoWDir().getPath();
                    Logger.getLogger(EMPApp.class.getName()).log(Level.SEVERE, null,message );
                    myExit(message);
                }
                else
                {
                    runAsAdmin(conf.getWoWDir().getPath());
                }
           } catch (Exception ex1) {
                Logger.getLogger("epicmusicplayer").log(Level.SEVERE,ex1.getMessage(),ex1);
                String message = "Cant write to: "+conf.getWoWDir().getPath();
                Logger.getLogger(EMPApp.class.getName()).log(Level.SEVERE, null,message );
                myExit(message);
            }
        }
        else if(admin!=0 && !checkWrite(path)) //running as admin, still cant write
        {
            String message = "Cant write to: "+conf.getWoWDir().getPath();
            Logger.getLogger(EMPApp.class.getName()).log(Level.SEVERE, null,message );
            myExit(message);
        }
        
        //+++++++++ wow folder is fine create music folder ++++++++++++
        try {
            File musicdir = createDefaultMusicDir(conf.getWoWDir());
            conf.setMusicDir(musicdir);
        } catch (Exception ex) {
                Logger.getLogger("epicmusicplayer").log(Level.SEVERE,ex.getMessage(),ex);
                String message = "Cant create folder \"MyMusic\" at: "+conf.getWoWDir().getPath();
                Logger.getLogger(EMPApp.class.getName()).log(Level.SEVERE, null,message );
                myExit(message);
        }
        
        //+++++++++ get account(s) and promt select if more then one +++++++++
        if(conf.getLoadfrom().equals(""))
        {
            try {
                conf.setLoadfrom(selectAccount((ArrayList) conf.getAccunts(conf.getWoWDir())));
                conf.setSaveto("all-accounts");
            } catch(FileNotFoundException ex){
                Logger.getLogger("epicmusicplayer").log(Level.SEVERE,ex.getMessage(),ex);

            }
        }
        
        //+++++++++ save the config +++++++++
        saveConfig(null);

        //+++++++++ show annoying message +++++++++
        if(conf.isShowWarning() && admin!=1){
            if (!showWarrantyMessage()){
                // user cancel
                //Logger.getLogger("epicmusicplayer").log(Level.FINE, "accept WarrantyMessage -> user cancel");
                Logger.getLogger("epicmusicplayer").log(Level.FINE, "accept WarrantyMessage -> user cancel");
                System.exit(0);
            }
        }

        //++++++++ show main window +++++++++++++++++
        MainView mainview = new MainView(this,getConf());
        
        this.addExitListener(mainview);
        show(mainview);
        
        if(conf.isShowWelcomeDialog()){
            WelcomeBox wb = new WelcomeBox(mainview.getFrame(), true, mainview);
            wb.setLocationRelativeTo(mainview.getFrame());
            wb.setVisible(true);
        }
        
        //Logger.getLogger("epicmusicplayer").log(Level.FINE, System.getProperty("java.io.tmpdir"));
        //String tmpFilePath = System.getProperty("java.io.tmpdir")+"/epicmusicplayer.conf"; 
        
        /*
        if (aboutBox == null) {
            JFrame mainFrame = EMPApp.getApplication().getMainFrame();
            aboutBox = new AboutBox(mainFrame);
            aboutBox.setLocationRelativeTo(mainFrame);
        }
        EMPApp.getApplication().show(aboutBox);
        */
          
        /*
        if(conf.isFirstRun()){
            JOptionPane.showMessageDialog(null,
                        "Please select a folder with mp3 files in it.",
                        "EpicMusicPlayer"+conf.getSavedVersion(),JOptionPane.PLAIN_MESSAGE);
            m.addMuiscFolder();
        }*/
    }

    /**
     * This method is to initialize the specified window by injecting resources.
     * Windows shown in our application come fully initialized from the GUI
     * builder, so this additional configuration is not needed.
     */
    @Override protected void configureWindow(java.awt.Window root) {
        
    }

    /**
     * A convenient static getter for the application instance.
     * @return the instance of EMPApp
     */
    public static EMPApp getApplication() {
        return Application.getInstance(EMPApp.class);
    }
    
   /*
   @Override
   public void exit(EventObject event) {
   
   }*/

   /*
   @Override
   protected void shutdown() {
           super.shutdown();
   }*/
    
      
    
    
    /**
     * Main method launching the application.
     */
    public static void main(String[] args) {   
        try{
            FileHandler handler = new FileHandler("errorlog.txt"); 
            handler.setFormatter(new SimpleFormatter());
            handler.setLevel(Level.ALL);
            handler.setFilter(null);
            
            
            Logger logger = Logger.getLogger("epicmusicplayer");
            logger.setLevel(Level.ALL);
            logger.addHandler(handler);
            //if (true) throw new Exception("Test"); 
            launch(EMPApp.class, args);
            
        }
        catch(Exception ex)
        {
            Logger.getLogger("epicmusicplayer").log(Level.SEVERE,ex.getMessage(),ex);
            myExit(ex.getMessage());
        }
    }

    public void runAsAdmin(String wowdir) throws Exception{
        if(admin==1){
           throw new Exception("Allready running as Admin!");
        }
        else
        {
            parameter = "admin=1";
            String apppath = getAppPath(); 
            Logger.getLogger("epicmusicplayer").log(Level.SEVERE, "Trying to run as Admin. exe path: "+apppath);
            UAC process = new UAC();
            //boolean result = process.launchElevated(apppath, "admin=1 wowdir="+wowdir);
            boolean result = process.launchElevated(apppath, parameter);

            Logger.getLogger("epicmusicplayer").log(Level.SEVERE, "Run as Admin result: "+result);
            //continue the new process, quit this one
            System.exit(0);
        }
    }

    public boolean checkWrite(String path)
    {
        /**
        SecurityManager manager = new SecurityManager();
        try {
            manager.checkWrite(path);
            return true;
        } catch (SecurityException ex) {
           Logger.getLogger("epicmusicplayer").log(Level.SEVERE,ex.getMessage(),ex);
           return false;
        }**/

        File testfile = new File(path+"/emp_test.txt");
        testfile.delete();
        try {
            boolean canwrite = testfile.createNewFile();
            testfile.delete();
            return canwrite;
        } catch (IOException ex) {
            Logger.getLogger(EMPApp.class.getName()).log(Level.SEVERE, null, ex);
            return false;
        }
    }
    
    public void saveConfig(JFrame frame) {
        try {
            conf.save();
        } catch (Exception e) {
            Logger.getLogger("epicmusicplayer").log(Level.SEVERE, e.getMessage(),e);
            JOptionPane.showMessageDialog(frame,
                    "Error saving the config:" +
                    e.getMessage(),
                    "EpicMusicPlayer Playlist Manager", JOptionPane.WARNING_MESSAGE);
        }
    }
    
    /**
     * Get the path to the application exe file
     * @return path
     */
    private String getAppPath()
    {

        String appPath = getClass().getProtectionDomain().getCodeSource().getLocation().getPath();
        appPath = appPath.substring(1, appPath.length());
        appPath = appPath.replaceAll("%20", " ");
        System.out.println(appPath);
        if (!appPath.endsWith(".exe"))
        {
            //appPath = "G:/created/coding/NetBeansProjects/EMP-PlaylistGenerator/PlaylistManager.exe";
            appPath="java";
            parameter = "-jar G:/created/coding/NetBeansProjects/EMP-PlaylistGenerator/dist/PlaylistManager_with_libs.jar "+parameter;
        }
        return appPath;
    }
    
    public File createDefaultMusicDir(File wowfolder) throws Exception
    {
        File musicdir = new File(wowfolder.getPath() +"/MyMusic");
        if(musicdir.exists())
        {
            return musicdir;
        }
        else if(musicdir.mkdir())
        {
            return musicdir;
        }
        else
        {
            throw new Exception("Could not create Music Folder at "+musicdir.getPath());
        }
    }

    public Config getConf() {
        return conf;
    }
    
    private static void myExit(String message) {
        myExit(message, null);
    }

    private static void myExit(String message,JFrame f) {
        if(message!=null){
             JOptionPane.showMessageDialog(f,
                "Sorry, the following error occured. Please check the errorlog.txt \n" +
                message,
                "EpicMusicPlayer Playlist Manager", JOptionPane.ERROR_MESSAGE);
        }
        System.exit(1);
    }
    
    /**
     * get account(s) and promt select if more then one
     * @param accounts
     * @return selected account
     */
    private String selectAccount(List accounts) {
        SelectAccountDialog accdialog;
        String selected = "";
        if (accounts.size() > 1) {
            accdialog = new SelectAccountDialog(null, true, accounts);
            //accdialog.setLocationRelativeTo(this.getFrame());
            accdialog.setVisible(true);
            selected = accdialog.getSelectedAccount();
        } else {
            selected = (String) accounts.get(0);
        }
        return selected;
    }
    
    private boolean showWarrantyMessage() {
        //first time running
        String message =
                "BECAUSE EPICMUSICPLAYER IS FREE OF CHARGE, THERE IS NO WARRANTY FOR THE PROGRAM.\n" +
                "THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.\n" +
                "SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, \n" +
                "REPAIR OR CORRECTION.\n";

        Object[] options = {"Agree",
            "No way!"
        };
        int n = JOptionPane.showOptionDialog(null,
                message,
                "EpicMusicPlayer Playlist Manager",
                JOptionPane.YES_NO_OPTION,
                JOptionPane.WARNING_MESSAGE,
                null, //do not use a custom Icon
                options, //the titles of buttons
                options[1]); //default button title

        if (n == 0) {
            return true;
        }
        return false;
    }
    
    private boolean selectWoWFolder() {
        JOptionPane.showMessageDialog(null,
                "Sorry, could not find the World of Warcraft folder. \n" +
                "Please select the folder where WoW is installed e.g: C:\\Program Files\\World of Warcraft",
                "EpicMusicPlayer Playlist Manager", JOptionPane.INFORMATION_MESSAGE);

        boolean selectetcorrect = false;
        JFileChooser jf;
        File wowfolder = null;
        //loop until user selects the correct folder, this may take a while^^
        while (!selectetcorrect) {
            jf = new JFileChooser();
            jf.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
            //jf.setCurrentDirectory(new java.io.File(System.getenv("ProgramFiles")));
            int returnVal = jf.showOpenDialog(null);

            if (returnVal == JFileChooser.APPROVE_OPTION) {
                try {
                    wowfolder = jf.getSelectedFile();
                    conf = new Config(configFile, wowfolder);
                    selectetcorrect = true;
                } catch (FileNotFoundException e) { //wrong folder selected
                    Logger.getLogger("epicmusicplayer").log(Level.INFO, e.getMessage()+" - "+wowfolder.getPath(),e);
                    JOptionPane.showMessageDialog(null,
                            e.getMessage() + ".\n" +
                            "Please select the folder where WoW is installed e.g: C:\\Program Files\\World of Warcraft",
                            "EpicMusicPlayer Playlist Manager", JOptionPane.WARNING_MESSAGE);
                }
                catch (IllegalArgumentException ex) { //cant create folder
                    Logger.getLogger("epicmusicplayer").log(Level.SEVERE, ex.getMessage(),ex);
                     JOptionPane.showMessageDialog(null,
                            ex.getMessage() + ".\n",
                            "EpicMusicPlayer Playlist Manager", JOptionPane.WARNING_MESSAGE);
                }
                catch (Exception e1) { //cant create folder
                    Logger.getLogger("epicmusicplayer").log(Level.SEVERE, e1.getMessage(),e1);
                    JOptionPane.showMessageDialog(null,
                            e1.getMessage() + ".\n" +
                            "Right click the PlaylistManager.exe and select run as Administrator or change the permissions on the WoW folder.",
                            "EpicMusicPlayer Playlist Manager", JOptionPane.WARNING_MESSAGE);
                }
            } else { //user clicked cancel
                JOptionPane.showMessageDialog(null,
                        "Could not create music directory, the program will close.",
                        "EpicMusicPlayer Playlist Manager", JOptionPane.WARNING_MESSAGE);
                return false;
            }
        }
        return true;
    }

    public void copyFiles(String strPath, String dstPath)
    {
        File src = new File(strPath);
        File dest = new File(dstPath);

        if (src.isDirectory()) {
            //if(dest.exists()!=true)
            boolean created = dest.mkdirs();
            String list[] = src.list();

            for (int i = 0; i < list.length; i++) {
                String dest1 = dest.getAbsolutePath() + File.separator + list[i];
                String src1 = src.getAbsolutePath() + File.separator + list[i];
                copyFiles(src1, dest1);
            }
        } else {
            try {
                String ext = src.getName().toUpperCase();
                
                    System.out.println("Copying: " + src + " to " + dest);
                    //f.log("Copying: " + src + " to " + dest);
                    FileChannel sourceChannel = new FileInputStream(src).getChannel();
                    FileChannel targetChannel = new FileOutputStream(dest).getChannel();
                    sourceChannel.transferTo(0, sourceChannel.size(), targetChannel);
                    sourceChannel.close();
                    targetChannel.close();
            } catch (IOException ex) {
                Logger.getLogger("epicmusicplayer").log(Level.SEVERE,ex.getMessage(),ex);
            }
        }
    }
}

