/**
 * EpicMusicPlayer Playlistgenerator
 *
 * @author yess
 */

package gui;

import app.Config;
import playlist.Playlists;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.nio.channels.FileChannel;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import net.iharder.dnd.FileDrop.Listener;

public class JTableDropListener implements Listener, Runnable {

    Playlists myGenerator;
    MainView f;
    Config conf;
    int toList;
    File[] files;
    List<String> sumList;
    
    public JTableDropListener(Playlists gen, MainView f, Config conf) {
        this.myGenerator = gen;
        this.f = f;
        this.conf = conf;


    }

    public void filesDropped(File[] files) {
        this.files = files;
        this.toList = f.getSelectetList();
        Thread thdrop = new Thread(this);
        thdrop.start();
    }

    public void filesDroppedThread(File[] files) {
        // handle file drop
        sumList = null;
        for (int i = 0; i < files.length; i++) {
            try {
                //System.out.println(files[i].getPath())
                File newfile = files[i];



                //newfile = newfile.replaceAll("\\\\", "/");
                //log("Adding file: "+newfile.getPath());
                System.out.println(newfile.getCanonicalFile());

                // in addon dir?
                File dest = conf.getMusicDir();
                //System.out.println("newfile: " + newfile.getPath());
                //System.out.println("addonpath: " + dest.getPath());
                
                
                // check if dropped file is in addondir
                if(newfile.getPath().toLowerCase().contains(dest.getPath().toLowerCase()))
                {
                    //in addondir do not copy
                    sumList = myGenerator.addFile(files[i], toList, sumList);
                } else {
                    File destf = new File(conf.getMusicDir() + "/" + files[i].getName());
                    if (!destf.isDirectory() && destf.exists()) {
                        //todo add new files to existing folder
                        //do not overwrite
                        f.log("Destination file already exist: " + destf);
                        sumList = myGenerator.addFile(destf, toList, sumList);
                    } else {
                        if(conf.isCopyfiles() | files[i].isFile()){
                            //copy and add
                            copyAddFiles(files[i].getPath(), destf.getPath());
                        }
                        else
                        {
                            //create link
                            String linkname = destf.getParentFile()+"/linkto-"+destf.getName();
                            System.out.println(linkname);
                            try{
                            conf.getJLink().createlink(linkname, files[i].getPath());
                            }catch(Exception e1){
                                Logger.getLogger(JTableDropListener.class.getName()).log(Level.INFO, null, e1);
                            }
                            sumList = myGenerator.addFile(new File(linkname), toList, sumList);
                        }
                    }
                }
            } catch (IOException ex) {
                Logger.getLogger(JTableDropListener.class.getName()).log(Level.SEVERE, null, ex);
            }
        }

        if(sumList != null){
            f.log("Summary:");
            int i;
            for(i=1;i<sumList.size();i++){
                f.log(sumList.get(i));
            }
            f.log("Added "+sumList.get(0)+" File(s).");
            f.log(""+(i-1)+" Error(s).");
            f.updatePlaylist();
        }
    }   // end filesDropped

    public void copyAddFiles(String strPath, String dstPath) {

        File src = new File(strPath);
        File dest = new File(dstPath);

        if (src.isDirectory()) {
            //if(dest.exists()!=true)
            boolean created = dest.mkdirs();
            String list[] = src.list();

            for (int i = 0; i < list.length; i++) {
                String dest1 = dest.getAbsolutePath() + File.separator + list[i];
                String src1 = src.getAbsolutePath() + File.separator + list[i];
                copyAddFiles(src1, dest1);
            }
        } else {
            try {
                String ext = src.getName().toUpperCase();
                if (ext.endsWith(".MP3") || ext.endsWith(".OGG") || ext.endsWith(".WAV") || ext.endsWith(".FLAC")) {
                    System.out.println("Copying: " + src + " to " + dest);
                    f.log("Copying: " + src + " to " + dest);
                    FileChannel sourceChannel = new FileInputStream(src).getChannel();
                    FileChannel targetChannel = new FileOutputStream(dest).getChannel();
                    sourceChannel.transferTo(0, sourceChannel.size(), targetChannel);
                    sourceChannel.close();
                    targetChannel.close();
                    sumList = myGenerator.addFile(dest, toList, sumList);

                } else {
                    f.log("Not a MP3/OGG/WAV/FLAC File. "+src.getName());
                    return;
                }

            } catch (IOException ex) {
                //Logger.getLogger(FileCopy.class.getName()).log(Level.SEVERE, null, ex);
                ex.printStackTrace();
                f.log("Error at File:" + src + " (" + ex + ")");
            }
        }
    }

    public void run() {
        filesDroppedThread(files);
    }
}
