/**
 * EpicMusicPlayer Playlistgenerator
 *
 * @author yess
 */
package gui;

import app.EMPPlayer;
import app.EMPApp;
import app.Config;
import java.awt.Desktop;
import javazoom.jlgui.basicplayer.BasicPlayerException;
import playlist.Playlists;
import playlist.Song;
import java.awt.event.WindowEvent;
import java.io.FileNotFoundException;
import java.util.EventObject;
import java.util.logging.Level;
import java.util.logging.Logger;
import javazoom.jl.decoder.JavaLayerException;
import org.jdesktop.application.Action;
import org.jdesktop.application.ResourceMap;
import org.jdesktop.application.SingleFrameApplication;
import org.jdesktop.application.FrameView;
import org.jdesktop.application.TaskMonitor;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import javax.swing.DefaultListModel;
import javax.swing.Timer;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileFilter;
import javax.swing.table.JTableHeader;
import net.iharder.dnd.FileDrop;
import org.jdesktop.application.Application.ExitListener;

/**
 * The application's main frame.
 */
public class MainView extends FrameView implements ExitListener {

    private Playlists myGenerator;
    private EMPPlayer player;
    private Config conf = null;
    //private JPopupMenu listpopup;
    //private JPopupMenu tablepopup;
    public MainView(SingleFrameApplication app, Config conf) {
        super(app);
        this.conf = conf;
        initComponents();

        /*
        listpopup = new JPopupMenu();
        listpopup.add(jMenuItemRename);
        listpopup.add(jMenuItemRemove);
        tablepopup = new JPopupMenu();
        tablepopup.add(jMenuItemRemoveSelected);
        tablepopup.add(jMenuSort);
         */

        /*
        menuItem = new JMenuItem("A popup menu item");
        menuItem.addActionListener(this);
        popup.add(menuItem);
        menuItem = new JMenuItem("Another popup menu item");
        menuItem.addActionListener(this);
        popup.add(menuItem);
        //Add listener to components that can bring up popup menus.
        MouseListener popupListener = new PopupListener();
        output.addMouseListener(popupListener);
        menuBar.addMouseListener(popupListener);
         */

        //initconfig();
        
        myGenerator = new Playlists(conf, jTextAreaLog);

        if(conf.isAddGameMusicMode()){
            setSong("Add game music mode", "");
            //myGenerator.addList("Game Music");
            myGenerator.addStoredIngameList("Best of WoW", "/gui/resources/GameMusic.lua", "Best of WoW");
            myGenerator.addStoredIngameList("Game Music", "/gui/resources/GameMusic.lua", "Game Music");
        }
        
        updatePlaylist();
        jList1.setSelectedIndex(0);

        initDragAndDrop();

        jTable1.setSurrendersFocusOnKeystroke(false);
        JTableHeader header = jTable1.getTableHeader();
        header.setReorderingAllowed(false);
        header.addMouseListener(new ColumnHeaderListener(jTable1, this, myGenerator));
        
        ImageIcon frameIcon = new ImageIcon(getClass().getResource("/gui/resources/icons/icon.png"));
        this.getFrame().setIconImage(frameIcon.getImage());

        // status bar initialization - message timeout, idle icon and busy animation, etc
        ResourceMap resourceMap = getResourceMap();
        int messageTimeout = resourceMap.getInteger("StatusBar.messageTimeout");
        messageTimer = new Timer(messageTimeout, new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                statusMessageLabel.setText("");
            }
        });
        messageTimer.setRepeats(false);
        int busyAnimationRate = resourceMap.getInteger("StatusBar.busyAnimationRate");
        for (int i = 0; i < busyIcons.length; i++) {
            busyIcons[i] = resourceMap.getIcon("StatusBar.busyIcons[" + i + "]");
        }
        busyIconTimer = new Timer(busyAnimationRate, new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                busyIconIndex = (busyIconIndex + 1) % busyIcons.length;
                statusAnimationLabel.setIcon(busyIcons[busyIconIndex]);
            }
        });
        idleIcon = resourceMap.getIcon("StatusBar.idleIcon");
        statusAnimationLabel.setIcon(idleIcon);
        progressBar.setVisible(false);

        // connecting action tasks to status bar via TaskMonitor
        TaskMonitor taskMonitor = new TaskMonitor(getApplication().getContext());
        taskMonitor.addPropertyChangeListener(new java.beans.PropertyChangeListener() {

            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                String propertyName = evt.getPropertyName();
                if ("started".equals(propertyName)) {
                    if (!busyIconTimer.isRunning()) {
                        statusAnimationLabel.setIcon(busyIcons[0]);
                        busyIconIndex = 0;
                        busyIconTimer.start();
                    }
                    progressBar.setVisible(true);
                    progressBar.setIndeterminate(true);
                } else if ("done".equals(propertyName)) {
                    busyIconTimer.stop();
                    statusAnimationLabel.setIcon(idleIcon);
                    progressBar.setVisible(false);
                    progressBar.setValue(0);
                } else if ("message".equals(propertyName)) {
                    String text = (String) (evt.getNewValue());
                    statusMessageLabel.setText((text == null) ? "" : text);
                    messageTimer.restart();
                } else if ("progress".equals(propertyName)) {
                    int value = (Integer) (evt.getNewValue());
                    progressBar.setVisible(true);
                    progressBar.setIndeterminate(false);
                    progressBar.setValue(value);
                }
            }

            public void windowOpened(WindowEvent e) {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public void windowClosing(WindowEvent e) {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public void windowClosed(WindowEvent e) {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public void windowIconified(WindowEvent e) {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public void windowDeiconified(WindowEvent e) {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public void windowActivated(WindowEvent e) {
                throw new UnsupportedOperationException("Not supported yet.");
            }

            public void windowDeactivated(WindowEvent e) {
                throw new UnsupportedOperationException("Not supported yet.");
            }
        });
        
    }

    public void setSong(String list, String title) {
        jLabelSongList.setText(list);
        jLabelSong.setText(title);
    }

    @Action
    public void showAboutBox() {
        if (aboutBox == null) {
            JFrame mainFrame = EMPApp.getApplication().getMainFrame();
            aboutBox = new AboutBox(mainFrame);
            aboutBox.setLocationRelativeTo(mainFrame);
        }
        EMPApp.getApplication().show(aboutBox);
    }

    public void addMuiscFolder() {
        JFileChooser jf = new JFileChooser(conf.getLastSelectedFolder());
        jf.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        //jf.setCurrentDirectory(new java.io.File(System.getenv("ProgramFiles")));

        jf.setMultiSelectionEnabled(true);

        int returnVal = jf.showOpenDialog(this.getFrame());

        if (returnVal == JFileChooser.APPROVE_OPTION) {
            JTableDropListener l = new JTableDropListener(myGenerator, this, conf);
            l.filesDropped(jf.getSelectedFiles());
            conf.setLastSelectedFolder(jf.getSelectedFile().getPath());
        }
    }

    private void addMusicFiles() {
        JFileChooser jf = new JFileChooser(conf.getLastSelectedFolder());
        //jf.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        //jf.setCurrentDirectory(new java.io.File(System.getenv("ProgramFiles")));

        jf.setMultiSelectionEnabled(true);
        jf.setFileFilter(new FileFilter() {

            @Override
            public boolean accept(File f) {
                String fname = f.getName().toLowerCase();
                if (f.isDirectory()) {
                    return true;
                }
                if (fname.endsWith(".mp3") || fname.endsWith(".wav") || fname.endsWith(".ogg") || fname.endsWith(".flac")) {
                    return true;
                }
                return false;
            }

            @Override
            public String getDescription() {
                return "*.mp3, *.wav, *.ogg, *.flac";
            }
            });

        int returnVal = jf.showOpenDialog(this.getFrame());

        if (returnVal == JFileChooser.APPROVE_OPTION) {
            JTableDropListener l = new JTableDropListener(myGenerator, this, conf);
            l.filesDropped(jf.getSelectedFiles());
            conf.setLastSelectedFolder(jf.getSelectedFile().getPath());
        }
    }

    private void delPlaylistList() {
        //last list selected
        if (jList1.getModel().getSize() == 1) {
            //default list can not be removed.
            int ret = JOptionPane.showConfirmDialog(this.getFrame(),
                    "The Last Playlist can not be removed! Remove all songs from list?",
                    "EpicMusicPlayer",
                    JOptionPane.YES_NO_CANCEL_OPTION);

            if (ret == JOptionPane.YES_OPTION) {
                myGenerator.clearPlaylist(0);
                updatePlaylist();
            }
            return;
        }

        try {

            int ret = JOptionPane.showConfirmDialog(this.getFrame(),
                    "Remove Playlist: " + myGenerator.getPlaylistName(jList1.getSelectedIndex()),
                    "EpicMusicPlayer",
                    JOptionPane.YES_NO_CANCEL_OPTION);

            if (ret == JOptionPane.YES_OPTION) {

                myGenerator.removePlaylist(jList1.getSelectedIndex());
                jList1.setSelectedIndex(0);
                updatePlaylist();
            }

        } catch (Exception e) {
            Logger.getLogger("epicmusicplayer").log(Level.SEVERE, e.getMessage(), e);
        }
    }

    private void delSong() {
        myGenerator.removeSongs(jTable1.getSelectedRows(), jList1.getSelectedIndex());
        jTable1.getSelectionModel().setSelectionInterval(jTable1.getSelectedRow(), jTable1.getSelectedRow());
        jTable1.updateUI();
    }

    private void removeFromSongsDisk() {
        myGenerator.deleteFromDisk(jTable1.getSelectedRows(), jList1.getSelectedIndex());
        jTable1.getSelectionModel().setSelectionInterval(jTable1.getSelectedRow(), jTable1.getSelectedRow());
        jTable1.updateUI();
    }

    /*
    private void initconfig() {

        // try load config
        try {
            conf.load();
            if (conf.isShowWarning()){
                if (!showWarrantyMessage()){
                    // user cancel
                    //Logger.getLogger("epicmusicplayer").log(Level.FINE, "accept WarrantyMessage -> user cancel");
                    Logger.getLogger("epicmusicplayer").log(Level.FINE, "accept WarrantyMessage -> user cancel");
                    System.exit(0);
                }
            }
            
        } catch (Exception e) {
            Logger.getLogger("epicmusicplayer").log(Level.FINE, e.getMessage(),e);
            
            if (!showWarrantyMessage()){
                // user cancel
                Logger.getLogger("epicmusicplayer").log(Level.FINE, "accept WarrantyMessage -> user cancel");
                System.exit(0);
            }
            
            //try read path from registry
            try {
                File wowfolder = conf.getWoWFolderRegistry();
                File musicdir = conf.createDefaultMusicDir(wowfolder);
                conf.setMusicDir(musicdir);
                conf.setLoadfrom(selectAccount((ArrayList) conf.getAccunts(conf.getWoWDir())));
                conf.setSaveto("all-accounts");
                saveConfig();
            } catch (Exception e1) {
                Logger.getLogger("epicmusicplayer").log(Level.FINE, e1.getMessage(),e1);
                //get wow folder from user oO
                if (selectWoWFolder()) {
                    saveConfig();
                } else {
                    //user cancel
                    Logger.getLogger("epicmusicplayer").log(Level.FINE, "Select WOW folder -> user cancel");
                    System.exit(0);
                }
            }
        }
        if(conf.isAddGameMusicMode()){
            setSong("Add game music mode", "");
        }
    }
    */

    /*
    public void showUpdateInfo() {

        String message =
                "A new ingame playlist is available.\n" +
                "Do you want to add the new list?.\n" +
                "\n" +
                "The UlduarRaid and ArgentTournament (a new event) songs\n" +
                "will only play with the 3.1 client.\n" +
                "\n" +
                "You can add the list any time from the menu:\n" +
                "Playlist -> Add Ingame Playlist.\n";


        Object[] options = {"Yes",
            "No Thanks"
        };
        int n = JOptionPane.showOptionDialog(null,
                message,
                "EpicMusicPlayer Playlist Manager",
                JOptionPane.YES_NO_OPTION,
                JOptionPane.QUESTION_MESSAGE,
                null, //do not use a custom Icon
                options, //the titles of buttons
                options[0]); //default button title

        System.out.println(n);
        if (n == 0) {
            System.out.println(true);
            jMenuItemAddIngameActionPerformed(null);
        
            message = "You should remove your old ingame playlist.";
            JOptionPane.showMessageDialog(null, message,"EpicMusicPlayer Playlist Manager",JOptionPane.INFORMATION_MESSAGE );
        }
    }
    */
    
    private boolean showWarrantyMessage() {
        //first time running
        String message =
                "BECAUSE EPICMUSICPLAYER IS FREE OF CHARGE, THERE IS NO WARRANTY FOR THE PROGRAM.\n" +
                "THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.\n" +
                "SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, \n" +
                "REPAIR OR CORRECTION.\n";

        Object[] options = {"Agree",
            "No way!"
        };
        int n = JOptionPane.showOptionDialog(null,
                message,
                "EpicMusicPlayer Playlist Manager",
                JOptionPane.YES_NO_OPTION,
                JOptionPane.WARNING_MESSAGE,
                null, //do not use a custom Icon
                options, //the titles of buttons
                options[1]); //default button title

        if (n == 0) {
            return true;
        }
        return false;
    }

    /*
    private void saveConfig() {
        try {
            conf.save();
        } catch (Exception e) {
            Logger.getLogger("epicmusicplayer").log(Level.SEVERE, e.getMessage(),e);
            JOptionPane.showMessageDialog(this.getFrame(),
                    "Error saving the config:" +
                    e.getMessage(),
                    "EpicMusicPlayer Playlist Manager", JOptionPane.WARNING_MESSAGE);
        }
    }
    */
    
    private void saveplaylist() {
        try {
            myGenerator.save(conf.getSaveto());
        } catch (Exception e) {
            Logger.getLogger("epicmusicplayer").log(Level.SEVERE,"Could not save the playlist: "+e.getMessage(),e);
            JOptionPane.showMessageDialog(null,
                    "Could not save the playlist: "+e.getMessage(),
                    "EpicMusicPlayer Playlist Manager", JOptionPane.WARNING_MESSAGE);
        }
    }

    

    private void initDragAndDrop() {


        JTableDropListener l = new JTableDropListener(myGenerator, this, conf);
        new FileDrop(jTable1, l);
        new FileDrop(jPanel5, l);
    /*
    // drop files handler
    new FileDrop(jTable1, new FileDrop.Listener() {
    public void filesDropped(java.io.File[] files) {
    // handle file drop
    for (int i = 0; i < files.length; i++) {
    //System.out.println(files[i].getPath())
    File newfile = files[i];
    //newfile = newfile.replaceAll("\\\\", "/");
    Logger.getLogger(MainView.class.getName()).log(Level.INFO, "add: " + newfile.getPath());
    //log("Adding file: "+newfile.getPath());    
    System.out.println(conf.getAddonPath());
    // in addon dir?
    File dest = new File(conf.getAddonPath());
    System.out.println("newfile: " + newfile.getPath());
    System.out.println("addonpath: " + dest.getPath());
    //if (newfile.contains(conf.getAddonPath() + "/")) {
    if (newfile.getPath().contains(dest.getPath())) {
    System.out.println("in addon dir ");
    myGenerator.addFile(files[i], jList1.getSelectedIndex());
    } else {
    //try {
    File destf = new File(conf.getAddonPath() + "/" + files[i].getName());
    //System.out.print("Copying from: "+files[i].getPath()+" to:"+destf);
    //log("Copying \""+files[i].getName()+"\" to addondir...");
    //FileCopy.copyFiles(files[i].getPath(), destf.getPath());
    //new FileCopy().copyFiles(files[i].getPath(), destf.getPath(),);
    copyAddFiles(files[i].getPath(), destf.getPath());
    //myGenerator.addFile(destf, jList1.getSelectedIndex());
    //} catch (IOException ex) {
    //   Logger.getLogger(MainView.class.getName()).log(Level.SEVERE, null, ex);
    //}
    }
    }
    }   // end filesDropped
    public void copyAddFiles(String strPath, String dstPath) {
    File src = new File(strPath);
    File dest = new File(dstPath);
    if (src.isDirectory()) {
    //if(dest.exists()!=true)
    dest.mkdirs();
    String list[] = src.list();
    for (int i = 0; i < list.length; i++) {
    String dest1 = dest.getAbsolutePath() + "\\" + list[i];
    String src1 = src.getAbsolutePath() + "\\" + list[i];
    copyAddFiles(src1, dest1);
    }
    } else {
    try {
    if(!src.getName().toUpperCase().endsWith(".MP3")){
    log("Not a MP3 File.");
    return;
    }
    System.out.println("Copying: " + src + " to " + dest);
    log("Copying: " + src + " to " + dest);
    FileChannel sourceChannel = new FileInputStream(src).getChannel();
    FileChannel targetChannel = new FileOutputStream(dest).getChannel();
    sourceChannel.transferTo(0, sourceChannel.size(), targetChannel);
    sourceChannel.close();
    targetChannel.close();
    myGenerator.addFile(dest, jList1.getSelectedIndex());
    } catch (IOException ex) {
    Logger.getLogger(FileCopy.class.getName()).log(Level.SEVERE, null, ex);
    log("Error at File:" + src + " (" + ex+")");
    }
    }
    }
    }); // end FileDrop.Listener
     */
    }

    private void play() {
        try {
            if (player != null) {
                player.stop();
                player.play(jList1.getSelectedIndex(), jTable1.getSelectedRow());

            } else {
                player = new EMPPlayer(myGenerator, conf, this);
                player.play(jList1.getSelectedIndex(), jTable1.getSelectedRow());
            }
        } catch (FileNotFoundException ex) {
            Logger.getLogger(MainView.class.getName()).log(Level.SEVERE, null, ex);
        } catch (BasicPlayerException ex) {
            Logger.getLogger(MainView.class.getName()).log(Level.SEVERE, null, ex);
        } catch (JavaLayerException ex) {
            Logger.getLogger(MainView.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public void updatePlaylist() {
        int selectedindex = 0;
        if (jList1.getSelectedIndex() > 0 && jList1.getSelectedIndex() < jList1.getModel().getSize()) {
            selectedindex = jList1.getSelectedIndex();
        }

        //update JList + menu
        DefaultListModel lm = new DefaultListModel();
        Song s;
        jMenuMove.removeAll();
        jMenuCopy.removeAll();
        jMenuPopupMove.removeAll();
        jMenuPopupCopy.removeAll();
        for (int listindex = 0; listindex < myGenerator.getPlaylistCount(); listindex++) {
            lm.addElement(myGenerator.getPlaylistName(listindex));
            //update menu

            jMenuCopy.add(new JMenuItemCopy(myGenerator.getPlaylistName(listindex), this, myGenerator));
            jMenuPopupCopy.add(new JMenuItemCopy(myGenerator.getPlaylistName(listindex), this, myGenerator));
            jMenuMove.add(new JMenuItemMove(myGenerator.getPlaylistName(listindex), this, myGenerator));
            jMenuPopupMove.add(new JMenuItemMove(myGenerator.getPlaylistName(listindex), this, myGenerator));
        }
        //jList1.setSelectedIndex(0);
        jList1.setModel(lm);
        jList1.setSelectedIndex(selectedindex);

        //update JTable
        TableModel model = new TableModel(myGenerator.getPlaylist(selectedindex));
        jTable1.setModel(model);
        AutofitTableColumns.autoResizeTable(jTable1, true, 25);

    }

    private void exit() {
        JOptionPane.showMessageDialog(null, "Save?", "EpicMusicPlayer", JOptionPane.WARNING_MESSAGE);
    //System.exit(0);

    }

    public void log(String text) {
        Date dt = new Date();
        SimpleDateFormat df = new SimpleDateFormat("HH:mm:ss");
        jTabbedPane1.setSelectedIndex(1);
        jTextAreaLog.append("[" + df.format(dt) + "] " + text + "\n");
        jTextAreaLog.setCaretPosition(jTextAreaLog.getDocument().getLength());
        jTextAreaLog.validate();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        mainPanel = new javax.swing.JPanel();
        jToolBar1 = new javax.swing.JToolBar();
        jButtonAddFolder = new javax.swing.JButton();
        jButtonAdd = new javax.swing.JButton();
        jButtonSave = new javax.swing.JButton();
        jSeparator6 = new javax.swing.JToolBar.Separator();
        jButtonDel = new javax.swing.JButton();
        jButtonDelList = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JToolBar.Separator();
        jButtonPlay = new javax.swing.JButton();
        jButtonStop = new javax.swing.JButton();
        jButtonPrev = new javax.swing.JButton();
        jButtonNext = new javax.swing.JButton();
        jSeparator2 = new javax.swing.JToolBar.Separator();
        jLabelSongList = new javax.swing.JLabel();
        jLabelSong = new javax.swing.JLabel();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel5 = new javax.swing.JPanel();
        jSplitPane1 = new javax.swing.JSplitPane();
        jScrollPane2 = new javax.swing.JScrollPane();
        jList1 = new javax.swing.JList();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jPanel3 = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        jTextAreaLog = new javax.swing.JTextArea();
        menuBar = new javax.swing.JMenuBar();
        javax.swing.JMenu fileMenu = new javax.swing.JMenu();
        jMenuItemAddMusic = new javax.swing.JMenuItem();
        jMenuItemAddFolder = new javax.swing.JMenuItem();
        jMenuItemSave = new javax.swing.JMenuItem();
        jSeparator5 = new javax.swing.JSeparator();
        javax.swing.JMenuItem exitMenuItem = new javax.swing.JMenuItem();
        jMenuEdit = new javax.swing.JMenu();
        jSeparator3 = new javax.swing.JSeparator();
        jMenuMove = new javax.swing.JMenu();
        jMenuCopy = new javax.swing.JMenu();
        jMenuItemRemoveSelected = new javax.swing.JMenuItem();
        jMenuItemRemoveFRomDisk = new javax.swing.JMenuItem();
        jMenuPlaylist = new javax.swing.JMenu();
        jMenuItemAddList = new javax.swing.JMenuItem();
        jMenuItemRename = new javax.swing.JMenuItem();
        jMenuItemRemove = new javax.swing.JMenuItem();
        jMenuItemAddIngame = new javax.swing.JMenuItem();
        jMenuItemAddTop50 = new javax.swing.JMenuItem();
        jMenuItemAmbiente = new javax.swing.JMenuItem();
        jSeparator4 = new javax.swing.JSeparator();
        jMenuSort = new javax.swing.JMenu();
        jMenuItemSortTitle = new javax.swing.JMenuItem();
        jMenuItemSortPath = new javax.swing.JMenuItem();
        jMenuItemSortArtist = new javax.swing.JMenuItem();
        jMenuItemSortAlbum = new javax.swing.JMenuItem();
        jMenuIemSortTime = new javax.swing.JMenuItem();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenuTools = new javax.swing.JMenu();
        jMenuItemRemoveDead = new javax.swing.JMenuItem();
        jMenuItem1 = new javax.swing.JMenuItem();
        javax.swing.JMenu helpMenu = new javax.swing.JMenu();
        jMenuItem2 = new javax.swing.JMenuItem();
        javax.swing.JMenuItem aboutMenuItem = new javax.swing.JMenuItem();
        statusPanel = new javax.swing.JPanel();
        javax.swing.JSeparator statusPanelSeparator = new javax.swing.JSeparator();
        statusMessageLabel = new javax.swing.JLabel();
        statusAnimationLabel = new javax.swing.JLabel();
        progressBar = new javax.swing.JProgressBar();
        jPanel2 = new javax.swing.JPanel();
        jPopupTable = new javax.swing.JPopupMenu();
        jMenuItemPlay = new javax.swing.JMenuItem();
        jMenuItemEdit = new javax.swing.JMenuItem();
        jMenuItemRemoveSelected1 = new javax.swing.JMenuItem();
        jMenuPopupMove = new javax.swing.JMenu();
        jMenuPopupCopy = new javax.swing.JMenu();
        jPopupList = new javax.swing.JPopupMenu();
        jMenuItemRename1 = new javax.swing.JMenuItem();
        jMenuItemRemove1 = new javax.swing.JMenuItem();

        mainPanel.setName("mainPanel"); // NOI18N

        jToolBar1.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jToolBar1.setFloatable(false);
        jToolBar1.setRollover(true);
        jToolBar1.setName("jToolBar1"); // NOI18N

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(app.EMPApp.class).getContext().getResourceMap(MainView.class);
        jButtonAddFolder.setIcon(resourceMap.getIcon("jButtonAddFolder.icon")); // NOI18N
        jButtonAddFolder.setText(resourceMap.getString("jButtonAddFolder.text")); // NOI18N
        jButtonAddFolder.setToolTipText(resourceMap.getString("jButtonAddFolder.toolTipText")); // NOI18N
        jButtonAddFolder.setFocusable(false);
        jButtonAddFolder.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButtonAddFolder.setName("jButtonAddFolder"); // NOI18N
        jButtonAddFolder.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButtonAddFolder.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonAddFolderActionPerformed(evt);
            }
        });
        jToolBar1.add(jButtonAddFolder);

        jButtonAdd.setIcon(resourceMap.getIcon("jButtonAdd.icon")); // NOI18N
        jButtonAdd.setText(resourceMap.getString("jButtonAdd.text")); // NOI18N
        jButtonAdd.setToolTipText(resourceMap.getString("jButtonAdd.toolTipText")); // NOI18N
        jButtonAdd.setFocusable(false);
        jButtonAdd.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButtonAdd.setName("jButtonAdd"); // NOI18N
        jButtonAdd.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButtonAdd.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonAddActionPerformed(evt);
            }
        });
        jToolBar1.add(jButtonAdd);

        jButtonSave.setIcon(resourceMap.getIcon("jButtonSave.icon")); // NOI18N
        jButtonSave.setText(resourceMap.getString("jButtonSave.text")); // NOI18N
        jButtonSave.setToolTipText(resourceMap.getString("jButtonSave.toolTipText")); // NOI18N
        jButtonSave.setFocusable(false);
        jButtonSave.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButtonSave.setName("jButtonSave"); // NOI18N
        jButtonSave.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButtonSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonSaveActionPerformed(evt);
            }
        });
        jToolBar1.add(jButtonSave);

        jSeparator6.setName("jSeparator6"); // NOI18N
        jToolBar1.add(jSeparator6);

        jButtonDel.setIcon(resourceMap.getIcon("jButtonDel.icon")); // NOI18N
        jButtonDel.setText(resourceMap.getString("jButtonDel.text")); // NOI18N
        jButtonDel.setToolTipText(resourceMap.getString("jButtonDel.toolTipText")); // NOI18N
        jButtonDel.setFocusable(false);
        jButtonDel.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButtonDel.setName("jButtonDel"); // NOI18N
        jButtonDel.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButtonDel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonDelActionPerformed(evt);
            }
        });
        jToolBar1.add(jButtonDel);

        jButtonDelList.setIcon(resourceMap.getIcon("jButtonDelList.icon")); // NOI18N
        jButtonDelList.setText(resourceMap.getString("jButtonDelList.text")); // NOI18N
        jButtonDelList.setToolTipText(resourceMap.getString("jButtonDelList.toolTipText")); // NOI18N
        jButtonDelList.setFocusable(false);
        jButtonDelList.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButtonDelList.setName("jButtonDelList"); // NOI18N
        jButtonDelList.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButtonDelList.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonDelListActionPerformed(evt);
            }
        });
        jToolBar1.add(jButtonDelList);

        jSeparator1.setName("jSeparator1"); // NOI18N
        jToolBar1.add(jSeparator1);

        jButtonPlay.setIcon(resourceMap.getIcon("jButtonPlay.icon")); // NOI18N
        jButtonPlay.setText(resourceMap.getString("jButtonPlay.text")); // NOI18N
        jButtonPlay.setToolTipText(resourceMap.getString("jButtonPlay.toolTipText")); // NOI18N
        jButtonPlay.setFocusable(false);
        jButtonPlay.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButtonPlay.setMargin(new java.awt.Insets(2, 0, 2, 0));
        jButtonPlay.setName("jButtonPlay"); // NOI18N
        jButtonPlay.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButtonPlay.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonPlayActionPerformed(evt);
            }
        });
        jToolBar1.add(jButtonPlay);

        jButtonStop.setIcon(resourceMap.getIcon("jButtonStop.icon")); // NOI18N
        jButtonStop.setText(resourceMap.getString("jButtonStop.text")); // NOI18N
        jButtonStop.setToolTipText(resourceMap.getString("jButtonStop.toolTipText")); // NOI18N
        jButtonStop.setFocusable(false);
        jButtonStop.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButtonStop.setMargin(new java.awt.Insets(2, 0, 2, 0));
        jButtonStop.setName("jButtonStop"); // NOI18N
        jButtonStop.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButtonStop.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonStopActionPerformed(evt);
            }
        });
        jToolBar1.add(jButtonStop);

        jButtonPrev.setIcon(resourceMap.getIcon("jButtonPrev.icon")); // NOI18N
        jButtonPrev.setText(resourceMap.getString("jButtonPrev.text")); // NOI18N
        jButtonPrev.setToolTipText(resourceMap.getString("jButtonPrev.toolTipText")); // NOI18N
        jButtonPrev.setFocusable(false);
        jButtonPrev.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButtonPrev.setMargin(new java.awt.Insets(2, 0, 2, 0));
        jButtonPrev.setName("jButtonPrev"); // NOI18N
        jButtonPrev.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButtonPrev.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonPrevActionPerformed(evt);
            }
        });
        jToolBar1.add(jButtonPrev);

        jButtonNext.setIcon(resourceMap.getIcon("jButtonNext.icon")); // NOI18N
        jButtonNext.setText(resourceMap.getString("jButtonNext.text")); // NOI18N
        jButtonNext.setToolTipText(resourceMap.getString("jButtonNext.toolTipText")); // NOI18N
        jButtonNext.setFocusable(false);
        jButtonNext.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButtonNext.setMargin(new java.awt.Insets(2, 0, 2, 0));
        jButtonNext.setName("jButtonNext"); // NOI18N
        jButtonNext.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButtonNext.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonNextActionPerformed(evt);
            }
        });
        jToolBar1.add(jButtonNext);

        jSeparator2.setName("jSeparator2"); // NOI18N
        jToolBar1.add(jSeparator2);

        jLabelSongList.setFont(resourceMap.getFont("jLabelSongList.font")); // NOI18N
        jLabelSongList.setForeground(resourceMap.getColor("jLabelSongList.foreground")); // NOI18N
        jLabelSongList.setText(resourceMap.getString("jLabelSongList.text")); // NOI18N
        jLabelSongList.setName("jLabelSongList"); // NOI18N
        jToolBar1.add(jLabelSongList);

        jLabelSong.setFont(resourceMap.getFont("jLabelSong.font")); // NOI18N
        jLabelSong.setForeground(resourceMap.getColor("jLabelSong.foreground")); // NOI18N
        jLabelSong.setText(resourceMap.getString("jLabelSong.text")); // NOI18N
        jLabelSong.setName("jLabelSong"); // NOI18N
        jToolBar1.add(jLabelSong);

        jTabbedPane1.setName("jTabbedPane1"); // NOI18N

        jPanel5.setName("jPanel5"); // NOI18N

        jSplitPane1.setName("jSplitPane1"); // NOI18N

        jScrollPane2.setName("jScrollPane2"); // NOI18N

        jList1.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        jList1.setName("jList1"); // NOI18N
        jList1.setSelectionBackground(resourceMap.getColor("jList1.selectionBackground")); // NOI18N
        jList1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jList1MouseReleased(evt);
            }
        });
        jList1.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                jList1ValueChanged(evt);
            }
        });
        jScrollPane2.setViewportView(jList1);

        jSplitPane1.setLeftComponent(jScrollPane2);

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jTable1.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jTable1.setFocusable(false);
        jTable1.setName("jTable1"); // NOI18N
        jTable1.setSelectionBackground(resourceMap.getColor("jTable1.selectionBackground")); // NOI18N
        jTable1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jTable1MouseClicked(evt);
            }
            public void mousePressed(java.awt.event.MouseEvent evt) {
                jTable1MousePressed(evt);
            }
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jTable1MouseReleased(evt);
            }
        });
        jScrollPane1.setViewportView(jTable1);

        jSplitPane1.setRightComponent(jScrollPane1);

        org.jdesktop.layout.GroupLayout jPanel5Layout = new org.jdesktop.layout.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jSplitPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 673, Short.MAX_VALUE)
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jSplitPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 548, Short.MAX_VALUE)
        );

        jTabbedPane1.addTab(resourceMap.getString("jPanel5.TabConstraints.tabTitle"), jPanel5); // NOI18N

        jPanel3.setName("jPanel3"); // NOI18N

        jScrollPane3.setName("jScrollPane3"); // NOI18N

        jTextAreaLog.setColumns(20);
        jTextAreaLog.setEditable(false);
        jTextAreaLog.setLineWrap(true);
        jTextAreaLog.setRows(5);
        jTextAreaLog.setName("jTextAreaLog"); // NOI18N
        jTextAreaLog.addCaretListener(new javax.swing.event.CaretListener() {
            public void caretUpdate(javax.swing.event.CaretEvent evt) {
                jTextAreaLogCaretUpdate(evt);
            }
        });
        jScrollPane3.setViewportView(jTextAreaLog);

        org.jdesktop.layout.GroupLayout jPanel3Layout = new org.jdesktop.layout.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPane3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 673, Short.MAX_VALUE)
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jScrollPane3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 548, Short.MAX_VALUE)
        );

        jTabbedPane1.addTab(resourceMap.getString("jPanel3.TabConstraints.tabTitle"), jPanel3); // NOI18N

        org.jdesktop.layout.GroupLayout mainPanelLayout = new org.jdesktop.layout.GroupLayout(mainPanel);
        mainPanel.setLayout(mainPanelLayout);
        mainPanelLayout.setHorizontalGroup(
            mainPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jTabbedPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 678, Short.MAX_VALUE)
            .add(jToolBar1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 678, Short.MAX_VALUE)
        );
        mainPanelLayout.setVerticalGroup(
            mainPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(mainPanelLayout.createSequentialGroup()
                .add(jToolBar1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jTabbedPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 573, Short.MAX_VALUE)
                .addContainerGap())
        );

        menuBar.setBorder(null);
        menuBar.setName("menuBar"); // NOI18N

        fileMenu.setText(resourceMap.getString("fileMenu.text")); // NOI18N
        fileMenu.setName("fileMenu"); // NOI18N

        jMenuItemAddMusic.setIcon(resourceMap.getIcon("jMenuItemAddMusic.icon")); // NOI18N
        jMenuItemAddMusic.setText(resourceMap.getString("jMenuItemAddMusic.text")); // NOI18N
        jMenuItemAddMusic.setName("jMenuItemAddMusic"); // NOI18N
        jMenuItemAddMusic.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemAddMusicActionPerformed(evt);
            }
        });
        fileMenu.add(jMenuItemAddMusic);

        jMenuItemAddFolder.setIcon(resourceMap.getIcon("jMenuItemAddFolder.icon")); // NOI18N
        jMenuItemAddFolder.setText(resourceMap.getString("jMenuItemAddFolder.text")); // NOI18N
        jMenuItemAddFolder.setName("jMenuItemAddFolder"); // NOI18N
        jMenuItemAddFolder.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemAddFolderActionPerformed(evt);
            }
        });
        fileMenu.add(jMenuItemAddFolder);

        jMenuItemSave.setIcon(resourceMap.getIcon("jMenuItemSave.icon")); // NOI18N
        jMenuItemSave.setText(resourceMap.getString("jMenuItemSave.text")); // NOI18N
        jMenuItemSave.setName("jMenuItemSave"); // NOI18N
        jMenuItemSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemSaveActionPerformed(evt);
            }
        });
        fileMenu.add(jMenuItemSave);

        jSeparator5.setName("jSeparator5"); // NOI18N
        fileMenu.add(jSeparator5);

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance(app.EMPApp.class).getContext().getActionMap(MainView.class, this);
        exitMenuItem.setAction(actionMap.get("quit")); // NOI18N
        exitMenuItem.setName("exitMenuItem"); // NOI18N
        fileMenu.add(exitMenuItem);

        menuBar.add(fileMenu);

        jMenuEdit.setText(resourceMap.getString("jMenuEdit.text")); // NOI18N
        jMenuEdit.setName("jMenuEdit"); // NOI18N
        jMenuEdit.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jMenuEditMouseReleased(evt);
            }
        });
        jMenuEdit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuEditActionPerformed(evt);
            }
        });

        jSeparator3.setName("jSeparator3"); // NOI18N
        jMenuEdit.add(jSeparator3);

        jMenuMove.setText(resourceMap.getString("jMenuMove.text")); // NOI18N
        jMenuMove.setName("jMenuMove"); // NOI18N
        jMenuEdit.add(jMenuMove);

        jMenuCopy.setText(resourceMap.getString("jMenuCopy.text")); // NOI18N
        jMenuCopy.setName("jMenuCopy"); // NOI18N
        jMenuEdit.add(jMenuCopy);

        jMenuItemRemoveSelected.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_DELETE, 0));
        jMenuItemRemoveSelected.setIcon(resourceMap.getIcon("jMenuItemRemoveSelected.icon")); // NOI18N
        jMenuItemRemoveSelected.setText(resourceMap.getString("jMenuItemRemoveSelected.text")); // NOI18N
        jMenuItemRemoveSelected.setName("jMenuItemRemoveSelected"); // NOI18N
        jMenuItemRemoveSelected.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemRemoveSelectedActionPerformed(evt);
            }
        });
        jMenuEdit.add(jMenuItemRemoveSelected);

        jMenuItemRemoveFRomDisk.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_DELETE, java.awt.event.InputEvent.ALT_MASK));
        jMenuItemRemoveFRomDisk.setText(resourceMap.getString("jMenuItemRemoveFRomDisk.text")); // NOI18N
        jMenuItemRemoveFRomDisk.setName("jMenuItemRemoveFRomDisk"); // NOI18N
        jMenuItemRemoveFRomDisk.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemRemoveFRomDiskActionPerformed(evt);
            }
        });
        jMenuEdit.add(jMenuItemRemoveFRomDisk);

        menuBar.add(jMenuEdit);

        jMenuPlaylist.setText(resourceMap.getString("jMenuPlaylist.text")); // NOI18N
        jMenuPlaylist.setName("jMenuPlaylist"); // NOI18N

        jMenuItemAddList.setIcon(resourceMap.getIcon("jMenuItemAddList.icon")); // NOI18N
        jMenuItemAddList.setText(resourceMap.getString("jMenuItemAddList.text")); // NOI18N
        jMenuItemAddList.setName("jMenuItemAddList"); // NOI18N
        jMenuItemAddList.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemAddListActionPerformed(evt);
            }
        });
        jMenuPlaylist.add(jMenuItemAddList);

        jMenuItemRename.setText(resourceMap.getString("jMenuItemRename.text")); // NOI18N
        jMenuItemRename.setName("jMenuItemRename"); // NOI18N
        jMenuItemRename.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemRenameActionPerformed(evt);
            }
        });
        jMenuPlaylist.add(jMenuItemRename);

        jMenuItemRemove.setIcon(resourceMap.getIcon("jMenuItemRemove.icon")); // NOI18N
        jMenuItemRemove.setText(resourceMap.getString("jMenuItemRemove.text")); // NOI18N
        jMenuItemRemove.setName("jMenuItemRemove"); // NOI18N
        jMenuItemRemove.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemRemoveActionPerformed(evt);
            }
        });
        jMenuPlaylist.add(jMenuItemRemove);

        jMenuItemAddIngame.setText(resourceMap.getString("jMenuItemAddIngame.text")); // NOI18N
        jMenuItemAddIngame.setName("jMenuItemAddIngame"); // NOI18N
        jMenuItemAddIngame.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemAddIngameActionPerformed(evt);
            }
        });
        jMenuPlaylist.add(jMenuItemAddIngame);

        jMenuItemAddTop50.setText(resourceMap.getString("jMenuItemAddTop50.text")); // NOI18N
        jMenuItemAddTop50.setName("jMenuItemAddTop50"); // NOI18N
        jMenuItemAddTop50.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemAddTop50ActionPerformed(evt);
            }
        });
        jMenuPlaylist.add(jMenuItemAddTop50);

        jMenuItemAmbiente.setText(resourceMap.getString("jMenuItemAmbiente.text")); // NOI18N
        jMenuItemAmbiente.setName("jMenuItemAmbiente"); // NOI18N
        jMenuItemAmbiente.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemAmbienteActionPerformed(evt);
            }
        });
        jMenuPlaylist.add(jMenuItemAmbiente);

        jSeparator4.setName("jSeparator4"); // NOI18N
        jMenuPlaylist.add(jSeparator4);

        jMenuSort.setText(resourceMap.getString("jMenuSort.text")); // NOI18N
        jMenuSort.setName("jMenuSort"); // NOI18N

        jMenuItemSortTitle.setText(resourceMap.getString("jMenuItemSortTitle.text")); // NOI18N
        jMenuItemSortTitle.setName("jMenuItemSortTitle"); // NOI18N
        jMenuItemSortTitle.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemSortTitleActionPerformed(evt);
            }
        });
        jMenuSort.add(jMenuItemSortTitle);

        jMenuItemSortPath.setText(resourceMap.getString("jMenuItemSortPath.text")); // NOI18N
        jMenuItemSortPath.setName("jMenuItemSortPath"); // NOI18N
        jMenuItemSortPath.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemSortPathActionPerformed(evt);
            }
        });
        jMenuSort.add(jMenuItemSortPath);

        jMenuItemSortArtist.setText(resourceMap.getString("jMenuItemSortArtist.text")); // NOI18N
        jMenuItemSortArtist.setName("jMenuItemSortArtist"); // NOI18N
        jMenuItemSortArtist.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemSortArtistActionPerformed(evt);
            }
        });
        jMenuSort.add(jMenuItemSortArtist);

        jMenuItemSortAlbum.setText(resourceMap.getString("jMenuItemSortAlbum.text")); // NOI18N
        jMenuItemSortAlbum.setName("jMenuItemSortAlbum"); // NOI18N
        jMenuItemSortAlbum.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemSortAlbumActionPerformed(evt);
            }
        });
        jMenuSort.add(jMenuItemSortAlbum);

        jMenuIemSortTime.setText(resourceMap.getString("jMenuIemSortTime.text")); // NOI18N
        jMenuIemSortTime.setName("jMenuIemSortTime"); // NOI18N
        jMenuIemSortTime.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuIemSortTimeActionPerformed(evt);
            }
        });
        jMenuSort.add(jMenuIemSortTime);

        jMenuPlaylist.add(jMenuSort);

        jMenuBar1.setName("jMenuBar1"); // NOI18N
        jMenuPlaylist.add(jMenuBar1);

        menuBar.add(jMenuPlaylist);

        jMenuTools.setText(resourceMap.getString("jMenuTools.text")); // NOI18N
        jMenuTools.setName("jMenuTools"); // NOI18N
        jMenuTools.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuToolsActionPerformed(evt);
            }
        });

        jMenuItemRemoveDead.setText(resourceMap.getString("jMenuItemRemoveDead.text")); // NOI18N
        jMenuItemRemoveDead.setName("jMenuItemRemoveDead"); // NOI18N
        jMenuItemRemoveDead.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemRemoveDeadActionPerformed(evt);
            }
        });
        jMenuTools.add(jMenuItemRemoveDead);

        jMenuItem1.setText(resourceMap.getString("jMenuItem1.text")); // NOI18N
        jMenuItem1.setName("jMenuItem1"); // NOI18N
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jMenuTools.add(jMenuItem1);

        menuBar.add(jMenuTools);

        helpMenu.setText(resourceMap.getString("helpMenu.text")); // NOI18N
        helpMenu.setName("helpMenu"); // NOI18N

        jMenuItem2.setText(resourceMap.getString("jMenuItem2.text")); // NOI18N
        jMenuItem2.setName("jMenuItem2"); // NOI18N
        jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem2ActionPerformed(evt);
            }
        });
        helpMenu.add(jMenuItem2);

        aboutMenuItem.setAction(actionMap.get("showAboutBox")); // NOI18N
        aboutMenuItem.setName("aboutMenuItem"); // NOI18N
        aboutMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aboutMenuItemActionPerformed(evt);
            }
        });
        helpMenu.add(aboutMenuItem);

        menuBar.add(helpMenu);

        statusPanel.setName("statusPanel"); // NOI18N

        statusPanelSeparator.setName("statusPanelSeparator"); // NOI18N

        statusMessageLabel.setName("statusMessageLabel"); // NOI18N

        statusAnimationLabel.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        statusAnimationLabel.setName("statusAnimationLabel"); // NOI18N

        progressBar.setName("progressBar"); // NOI18N

        org.jdesktop.layout.GroupLayout statusPanelLayout = new org.jdesktop.layout.GroupLayout(statusPanel);
        statusPanel.setLayout(statusPanelLayout);
        statusPanelLayout.setHorizontalGroup(
            statusPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(statusPanelSeparator, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 678, Short.MAX_VALUE)
            .add(statusPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(statusMessageLabel)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 504, Short.MAX_VALUE)
                .add(progressBar, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(statusAnimationLabel)
                .addContainerGap())
        );
        statusPanelLayout.setVerticalGroup(
            statusPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(statusPanelLayout.createSequentialGroup()
                .add(statusPanelSeparator, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(statusPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(statusMessageLabel)
                    .add(statusAnimationLabel)
                    .add(progressBar, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(3, 3, 3))
        );

        jPanel2.setName("jPanel2"); // NOI18N

        org.jdesktop.layout.GroupLayout jPanel2Layout = new org.jdesktop.layout.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 100, Short.MAX_VALUE)
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 100, Short.MAX_VALUE)
        );

        jPopupTable.setName("jPopupTable"); // NOI18N

        jMenuItemPlay.setText(resourceMap.getString("jMenuItemPlay.text")); // NOI18N
        jMenuItemPlay.setName("jMenuItemPlay"); // NOI18N
        jMenuItemPlay.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemPlayActionPerformed(evt);
            }
        });
        jPopupTable.add(jMenuItemPlay);

        jMenuItemEdit.setText(resourceMap.getString("jMenuItemEdit.text")); // NOI18N
        jMenuItemEdit.setName("jMenuItemEdit"); // NOI18N
        jMenuItemEdit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemEditActionPerformed(evt);
            }
        });
        jPopupTable.add(jMenuItemEdit);

        jMenuItemRemoveSelected1.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_DELETE, 0));
        jMenuItemRemoveSelected1.setIcon(resourceMap.getIcon("jMenuItemRemoveSelected.icon")); // NOI18N
        jMenuItemRemoveSelected1.setText(resourceMap.getString("jMenuItemRemoveSelected1.text")); // NOI18N
        jMenuItemRemoveSelected1.setName("jMenuItemRemoveSelected1"); // NOI18N
        jMenuItemRemoveSelected1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemRemoveSelected1ActionPerformed(evt);
            }
        });
        jPopupTable.add(jMenuItemRemoveSelected1);

        jMenuPopupMove.setText(resourceMap.getString("jMenuPopupMove.text")); // NOI18N
        jMenuPopupMove.setName("jMenuPopupMove"); // NOI18N
        jPopupTable.add(jMenuPopupMove);

        jMenuPopupCopy.setText(resourceMap.getString("jMenuPopupCopy.text")); // NOI18N
        jMenuPopupCopy.setName("jMenuPopupCopy"); // NOI18N
        jPopupTable.add(jMenuPopupCopy);

        jPopupList.setName("jPopupList"); // NOI18N

        jMenuItemRename1.setText(resourceMap.getString("jMenuItemRename1.text")); // NOI18N
        jMenuItemRename1.setName("jMenuItemRename1"); // NOI18N
        jMenuItemRename1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemRename1ActionPerformed(evt);
            }
        });
        jPopupList.add(jMenuItemRename1);

        jMenuItemRemove1.setIcon(resourceMap.getIcon("jMenuItemRemove1.icon")); // NOI18N
        jMenuItemRemove1.setText(resourceMap.getString("jMenuItemRemove1.text")); // NOI18N
        jMenuItemRemove1.setName("jMenuItemRemove1"); // NOI18N
        jMenuItemRemove1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemRemove1ActionPerformed(evt);
            }
        });
        jPopupList.add(jMenuItemRemove1);

        setComponent(mainPanel);
        setMenuBar(menuBar);
        setStatusBar(statusPanel);
        setToolBar(jToolBar1);
        addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                formPropertyChange(evt);
            }
        });
    }// </editor-fold>//GEN-END:initComponents
    private void jMenuItemRemoveSelectedActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemRemoveSelectedActionPerformed
        myGenerator.removeSongs(jTable1.getSelectedRows(), jList1.getSelectedIndex());
        jTable1.getSelectionModel().setSelectionInterval(jTable1.getSelectedRow(), jTable1.getSelectedRow());
        jTable1.updateUI();
    }//GEN-LAST:event_jMenuItemRemoveSelectedActionPerformed
                
	private void jButtonSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSaveActionPerformed
            saveplaylist();
    }//GEN-LAST:event_jButtonSaveActionPerformed

	private void jMenuItemAddListActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemAddListActionPerformed

		String listname = JOptionPane.showInputDialog(this.getFrame(), "Playlistname:", this.getFrame().getTitle(), JOptionPane.PLAIN_MESSAGE);
		if (listname.length() > 0) {
			//todo: error message
			myGenerator.addList(listname);
			updatePlaylist();
		}
	}//GEN-LAST:event_jMenuItemAddListActionPerformed

	private void jButtonPlayActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonPlayActionPerformed
		play();
	}//GEN-LAST:event_jButtonPlayActionPerformed

	private void jButtonStopActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonStopActionPerformed
		player.stop();
	}//GEN-LAST:event_jButtonStopActionPerformed

	private void jButtonNextActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonNextActionPerformed
		player.playnext();
	}//GEN-LAST:event_jButtonNextActionPerformed

	private void jButtonPrevActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonPrevActionPerformed
		player.playlast();
	}//GEN-LAST:event_jButtonPrevActionPerformed

	private void jButtonDelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonDelActionPerformed
		delSong();
	}//GEN-LAST:event_jButtonDelActionPerformed

	private void formPropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_formPropertyChange
		// TODO add your handling code here:
	}//GEN-LAST:event_formPropertyChange

        private void jMenuItemRemoveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemRemoveActionPerformed
		delPlaylistList();
}//GEN-LAST:event_jMenuItemRemoveActionPerformed

        private void jMenuItemSortTitleActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemSortTitleActionPerformed
            myGenerator.sortPlaylistByTitle(jList1.getSelectedIndex());
            updatePlaylist();
}//GEN-LAST:event_jMenuItemSortTitleActionPerformed

        private void jMenuItemSortPathActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemSortPathActionPerformed
            myGenerator.sortPlaylistByPath(jList1.getSelectedIndex());
            updatePlaylist();
}//GEN-LAST:event_jMenuItemSortPathActionPerformed

        private void jMenuItemSortAlbumActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemSortAlbumActionPerformed
            myGenerator.sortPlaylistByAlbum(jList1.getSelectedIndex());
            updatePlaylist();
        }//GEN-LAST:event_jMenuItemSortAlbumActionPerformed

        private void jMenuIemSortTimeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuIemSortTimeActionPerformed
            myGenerator.sortPlaylistByTime(jList1.getSelectedIndex());
            updatePlaylist();
        }//GEN-LAST:event_jMenuIemSortTimeActionPerformed

        private void jMenuItemSortArtistActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemSortArtistActionPerformed
            myGenerator.sortPlaylistByArtist(jList1.getSelectedIndex());
            updatePlaylist();
        }//GEN-LAST:event_jMenuItemSortArtistActionPerformed

        private void jMenuItemSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemSaveActionPerformed
            saveplaylist();
        }//GEN-LAST:event_jMenuItemSaveActionPerformed

        private void jMenuItemAddMusicActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemAddMusicActionPerformed
            addMusicFiles();
        }//GEN-LAST:event_jMenuItemAddMusicActionPerformed

        private void jMenuItemRenameActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemRenameActionPerformed
            renamePlaylist();
        }//GEN-LAST:event_jMenuItemRenameActionPerformed

        private void jMenuItemAddFolderActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemAddFolderActionPerformed
            addMuiscFolder();             
}//GEN-LAST:event_jMenuItemAddFolderActionPerformed

        private void jMenuItemRename1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemRename1ActionPerformed
            renamePlaylist();
        }//GEN-LAST:event_jMenuItemRename1ActionPerformed

        private void jMenuItemRemove1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemRemove1ActionPerformed
            delPlaylistList();
        }//GEN-LAST:event_jMenuItemRemove1ActionPerformed

        private void jMenuItemRemoveSelected1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemRemoveSelected1ActionPerformed
            delSong();
        }//GEN-LAST:event_jMenuItemRemoveSelected1ActionPerformed

        private void jMenuItemPlayActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemPlayActionPerformed
            play();
        }//GEN-LAST:event_jMenuItemPlayActionPerformed

        private void jMenuEditActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuEditActionPerformed
            
        }//GEN-LAST:event_jMenuEditActionPerformed

        private void jMenuEditMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jMenuEditMouseReleased
            
        }//GEN-LAST:event_jMenuEditMouseReleased

        private void jButtonDelListActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonDelListActionPerformed
            delPlaylistList();
        }//GEN-LAST:event_jButtonDelListActionPerformed

        private void jButtonAddFolderActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAddFolderActionPerformed
            addMuiscFolder();
        }//GEN-LAST:event_jButtonAddFolderActionPerformed

        private void jButtonAddActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAddActionPerformed
            addMusicFiles();
        }//GEN-LAST:event_jButtonAddActionPerformed

        private void jTextAreaLogCaretUpdate(javax.swing.event.CaretEvent evt) {//GEN-FIRST:event_jTextAreaLogCaretUpdate
            jTabbedPane1.setSelectedIndex(1);
            //jScrollPane3.getVerticalScrollBar().setValue(jScrollPane3.getVerticalScrollBar().getMaximum());
            //jTextAreaLog.setCaretPosition(jTextAreaLog.getText().length());
            //jScrollPane3.validate();
        }//GEN-LAST:event_jTextAreaLogCaretUpdate

        private void jMenuItemRemoveFRomDiskActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemRemoveFRomDiskActionPerformed
            removeFromSongsDisk();
}//GEN-LAST:event_jMenuItemRemoveFRomDiskActionPerformed

        private void jMenuToolsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuToolsActionPerformed
            
           
            
        }//GEN-LAST:event_jMenuToolsActionPerformed

        private void aboutMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aboutMenuItemActionPerformed
            // TODO add your handling code here:
        }//GEN-LAST:event_aboutMenuItemActionPerformed

        private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
             //JFrame mainFrame = EMPApp.getApplication().getMainFrame();
             OptionsDialog op = new OptionsDialog(this.getFrame(),true,conf);
             op.setLocationRelativeTo(this.getFrame());
             //op.setVisible(true);
            
             EMPApp.getApplication().show(op);
        }//GEN-LAST:event_jMenuItem1ActionPerformed

        
       
        
        private void jMenuItemEditActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemEditActionPerformed
            
            //jTable1.setEditingColumn(jTable1.getSelectedColumn());
            //jTable1.setEditingRow(jTable1.getSelectedRow());
            //jTable1.setDefaultEditor(columnClass, editor)
            //jTable1.setCellEditor(new DefaultCellEditor(new JTextField()));
            jTable1.editCellAt(jTable1.getSelectedRow(),jTable1.getSelectedColumn());
            //jTable1
        }//GEN-LAST:event_jMenuItemEditActionPerformed

        private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
            try {
                URI uri = new URI("http://wow.curseforge.com/addons/epic-music-player/pages/frequently-asked-questions/");
                Desktop.getDesktop().browse(uri);
            } catch (URISyntaxException ex) {
                Logger.getLogger(AboutBox.class.getName()).log(Level.SEVERE, null, ex);
            } catch (IOException ex) {
                Logger.getLogger(AboutBox.class.getName()).log(Level.SEVERE, null, ex);

            }
        }//GEN-LAST:event_jMenuItem2ActionPerformed

        private void jTable1MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTable1MouseReleased
            if (evt.isPopupTrigger()) {
                for(int i:jTable1.getSelectedRows()) {
                    if(jTable1.rowAtPoint(evt.getPoint())==i){
                        jPopupTable.show(evt.getComponent(),
                                evt.getX(), evt.getY());
                        return;
                    }
                    
                }
                jTable1.getSelectionModel().setSelectionInterval(jTable1.rowAtPoint(evt.getPoint()), jTable1.rowAtPoint(evt.getPoint()) );
                
                jPopupTable.show(evt.getComponent(),
                        evt.getX(), evt.getY());
            }
        }//GEN-LAST:event_jTable1MouseReleased

        private void jTable1MousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTable1MousePressed
            
        }//GEN-LAST:event_jTable1MousePressed

        private void jTable1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTable1MouseClicked
            if (evt.getClickCount() >= 2) {
                play();
            }
        }//GEN-LAST:event_jTable1MouseClicked

        private void jList1ValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_jList1ValueChanged
            List savedplaylists = myGenerator.getSavedPlaylists();
            
            int listindex = 0;
            if(jList1.getSelectedIndex() > 0 && jList1.getSelectedIndex() < jList1.getModel().getSize()) {
                listindex = jList1.getSelectedIndex();
            }
            TableModel model = new TableModel((ArrayList) (savedplaylists.get(listindex)));
            jTable1.setModel(model);
            
        /*
        //jtable1.setDefaultRenderer( Point.class, new PointRender());
        TableRowSorter<TableModel> sorter = new TableRowSorter<TableModel>();
        jTable1.setRowSorter( sorter );
        sorter.setModel(model);
        sorter.addRowSorterListener(new RowSorterListener() {
         
            public void sorterChanged(RowSorterEvent e) {
                System.out.println(e.getType());
                System.out.println(jTable1.getSelectedColumn());
                EMPTableModel m = (EMPTableModel)jTable1.getModel();
                myGenerator.replaceList(m.getList(), jList1.getSelectedIndex());
            }
        });
         */
            
            AutofitTableColumns.autoResizeTable(jTable1, true, 25);
        }//GEN-LAST:event_jList1ValueChanged

        private void jList1MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jList1MouseReleased
            if (evt.isPopupTrigger()) {
                jList1.setSelectedIndex( jList1.locationToIndex(evt.getPoint()) );
                
                jPopupList.show(evt.getComponent(),
                        evt.getX(), evt.getY());
            }
        }//GEN-LAST:event_jList1MouseReleased

        private void jMenuItemRemoveDeadActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemRemoveDeadActionPerformed
            
           
            class ThreadRemoveDead implements Runnable {
                // This method is called when the thread runs
                public void run() {
                    myGenerator.removeDead();
                }
            }
            // Create the object with the run() method
            Runnable runnable = new ThreadRemoveDead();
            // Create the thread supplying it with the runnable object
            Thread thread = new Thread(runnable);
            thread.start();
            
        }//GEN-LAST:event_jMenuItemRemoveDeadActionPerformed

        private void jMenuItemAmbienteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemAmbienteActionPerformed
            String listname = JOptionPane.showInputDialog(this.getFrame(), "Playlistname:", this.getFrame().getTitle(), JOptionPane.PLAIN_MESSAGE);
            if (listname.length() > 0) {
                //todo: error message
                myGenerator.addStoredIngameList(listname, "/gui/resources/AmbienteList.lua", "ambiente");
                updatePlaylist();
            }
}//GEN-LAST:event_jMenuItemAmbienteActionPerformed

        private void jMenuItemAddTop50ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemAddTop50ActionPerformed
            String listname = JOptionPane.showInputDialog(this.getFrame(), "Playlistname:", this.getFrame().getTitle(), JOptionPane.PLAIN_MESSAGE);
        if (listname.length() > 0) {
            //todo: error message
            myGenerator.addStoredIngameList(listname, "/gui/resources/GameMusic.lua", "Best of WoW");
            updatePlaylist();
        }
        }//GEN-LAST:event_jMenuItemAddTop50ActionPerformed

    private void jButtonNewActionPerformed(java.awt.event.ActionEvent evt) {
        String listname = JOptionPane.showInputDialog(this.getFrame(), "Playlistname:", this.getFrame().getTitle(), JOptionPane.PLAIN_MESSAGE);
        if (listname.length() > 0) {
            //todo: error message
            myGenerator.addList(listname);
            updatePlaylist();
        }
    }

    private void jMenuItemAddIngameActionPerformed(java.awt.event.ActionEvent evt) {
        String listname = JOptionPane.showInputDialog(this.getFrame(), "Playlistname:", this.getFrame().getTitle(), JOptionPane.PLAIN_MESSAGE);
        if (listname.length() > 0) {
            //todo: error message
            myGenerator.addStoredIngameList(listname, "/gui/resources/GameMusic.lua", "Game Music");
            updatePlaylist();
        }
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonAdd;
    private javax.swing.JButton jButtonAddFolder;
    private javax.swing.JButton jButtonDel;
    private javax.swing.JButton jButtonDelList;
    private javax.swing.JButton jButtonNext;
    private javax.swing.JButton jButtonPlay;
    private javax.swing.JButton jButtonPrev;
    private javax.swing.JButton jButtonSave;
    private javax.swing.JButton jButtonStop;
    private javax.swing.JLabel jLabelSong;
    private javax.swing.JLabel jLabelSongList;
    private javax.swing.JList jList1;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenu jMenuCopy;
    private javax.swing.JMenu jMenuEdit;
    private javax.swing.JMenuItem jMenuIemSortTime;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JMenuItem jMenuItemAddFolder;
    private javax.swing.JMenuItem jMenuItemAddIngame;
    private javax.swing.JMenuItem jMenuItemAddList;
    private javax.swing.JMenuItem jMenuItemAddMusic;
    private javax.swing.JMenuItem jMenuItemAddTop50;
    private javax.swing.JMenuItem jMenuItemAmbiente;
    private javax.swing.JMenuItem jMenuItemEdit;
    private javax.swing.JMenuItem jMenuItemPlay;
    private javax.swing.JMenuItem jMenuItemRemove;
    private javax.swing.JMenuItem jMenuItemRemove1;
    private javax.swing.JMenuItem jMenuItemRemoveDead;
    private javax.swing.JMenuItem jMenuItemRemoveFRomDisk;
    private javax.swing.JMenuItem jMenuItemRemoveSelected;
    private javax.swing.JMenuItem jMenuItemRemoveSelected1;
    private javax.swing.JMenuItem jMenuItemRename;
    private javax.swing.JMenuItem jMenuItemRename1;
    private javax.swing.JMenuItem jMenuItemSave;
    private javax.swing.JMenuItem jMenuItemSortAlbum;
    private javax.swing.JMenuItem jMenuItemSortArtist;
    private javax.swing.JMenuItem jMenuItemSortPath;
    private javax.swing.JMenuItem jMenuItemSortTitle;
    private javax.swing.JMenu jMenuMove;
    private javax.swing.JMenu jMenuPlaylist;
    private javax.swing.JMenu jMenuPopupCopy;
    private javax.swing.JMenu jMenuPopupMove;
    private javax.swing.JMenu jMenuSort;
    private javax.swing.JMenu jMenuTools;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPopupMenu jPopupList;
    private javax.swing.JPopupMenu jPopupTable;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JToolBar.Separator jSeparator1;
    private javax.swing.JToolBar.Separator jSeparator2;
    private javax.swing.JSeparator jSeparator3;
    private javax.swing.JSeparator jSeparator4;
    private javax.swing.JSeparator jSeparator5;
    private javax.swing.JToolBar.Separator jSeparator6;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTable jTable1;
    private javax.swing.JTextArea jTextAreaLog;
    private javax.swing.JToolBar jToolBar1;
    private javax.swing.JPanel mainPanel;
    private javax.swing.JMenuBar menuBar;
    private javax.swing.JProgressBar progressBar;
    private javax.swing.JLabel statusAnimationLabel;
    private javax.swing.JLabel statusMessageLabel;
    private javax.swing.JPanel statusPanel;
    // End of variables declaration//GEN-END:variables
    private final Timer messageTimer;
    private final Timer busyIconTimer;
    private final Icon idleIcon;
    private final Icon[] busyIcons = new Icon[15];
    private int busyIconIndex = 0;
    private JDialog aboutBox;

    public boolean canExit(EventObject arg0) {
        

            if (!conf.isSaved()) {
                int ret = JOptionPane.showConfirmDialog(this.getFrame(), "Save Playlist?", "EpicMusicPlayer", JOptionPane.YES_NO_CANCEL_OPTION);

                if (ret == JOptionPane.YES_OPTION) {
                    saveplaylist();
                    return true;
                }
                if (ret == JOptionPane.NO_OPTION) {
                    return true; //exit program
                }
                return false; // no exit
            }
        try {
            EMPApp.getApplication().saveConfig(this.getFrame());
        } catch (Exception ex) {
            Logger.getLogger(MainView.class.getName()).log(Level.SEVERE, null, ex);
        }
        return true;
    }

    public void willExit(EventObject arg0) {
            //throw new UnsupportedOperationException("Not supported yet.");
    }

    public int getSelectetList()
    {
        return jList1.getSelectedIndex();
    }

    public int[] getSelectetSongs()
    {
        return jTable1.getSelectedRows();
    }

    private void renamePlaylist() {
        String listname = JOptionPane.showInputDialog(this.getFrame(), "New Playlistname:", this.getFrame().getTitle(), JOptionPane.PLAIN_MESSAGE);
            if (listname.length() > 0) {
                try {

                    myGenerator.renamePlaylist(jList1.getSelectedIndex(), listname);
                    updatePlaylist();
                } catch (Exception ex) {
                    Logger.getLogger(MainView.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
    }
}


