/**
 * EpicMusicPlayer Playlistgenerator
 *
 * @author yess
 */
package gui;

import app.Config;
import app.EMPApp;
import app.Junction;
import java.io.File;
import java.io.FileNotFoundException;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;

public class OptionsDialog extends javax.swing.JDialog {

    private Config conf;

    /** Creates new form OptionsDialog */
    public OptionsDialog(java.awt.Frame parent, boolean modal, Config conf) {
        super(parent, modal);


        this.conf = conf;
        initComponents();

        buttonGroup1.add(jRadioButtonCopy);
        buttonGroup1.add(jRadioButtonLink);

        if (conf.isShowWarning()) {
            jCheckBoxShowWarning.setSelected(true);
        } else {
            jCheckBoxShowWarning.setSelected(false);
        }
        
        if (conf.isShowWelcomeDialog()) {
            jCheckBoxShowWelcom.setSelected(true);
        } else {
            jCheckBoxShowWelcom.setSelected(false);
        }
        
        try {
            Junction j = new Junction();

            if (conf.isCopyfiles()) {
                jRadioButtonCopy.setSelected(true);
            } else {
                jRadioButtonLink.setSelected(true);
            }
        } catch (Exception ex) {
            Logger.getLogger(OptionsDialog.class.getName()).log(Level.SEVERE, null, ex);
            jLabelCopy.setText("Create links disabled: "+ex.getMessage());
            jRadioButtonCopy.setEnabled(false);
            jRadioButtonLink.setEnabled(false);
            jRadioButtonCopy.setSelected(true);
        }
        
        try {
            jTextMusicDir.setText(conf.getMusicDir().getPath());

            Object[] items = conf.getAccunts(conf.getWoWDir()).toArray();
            DefaultComboBoxModel model = new DefaultComboBoxModel(items);
            jComboBoxLoad.setModel(model);

            List l = conf.getAccunts(conf.getWoWDir());
            if (l.size() == 1) {
                jComboBoxLoad.setEnabled(false);
                jComboBoxSave.setEnabled(false);
            }

            l.add("all-accounts");
            items = l.toArray();
            model = new DefaultComboBoxModel(items);
            jComboBoxSave.setModel(model);

            jComboBoxLoad.setSelectedItem(conf.getLoadfrom());
            jComboBoxSave.setSelectedItem(conf.getSaveto());
        } catch (FileNotFoundException ex) {
            Logger.getLogger(OptionsDialog.class.getName()).log(Level.SEVERE, null, ex);
            jComboBoxLoad.setEnabled(false);
            jComboBoxSave.setEnabled(false);
        }


        if (conf.isDuplicate()) {
            jCheckBoxDublicate.setSelected(true);
        } else {
            jCheckBoxDublicate.setSelected(false);
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        jTextMusicDir = new javax.swing.JTextField();
        jButtonOk = new javax.swing.JButton();
        jButtonCancel = new javax.swing.JButton();
        jButtonBrowse = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        jComboBoxLoad = new javax.swing.JComboBox();
        jComboBoxSave = new javax.swing.JComboBox();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        jCheckBoxDublicate = new javax.swing.JCheckBox();
        jRadioButtonCopy = new javax.swing.JRadioButton();
        jRadioButtonLink = new javax.swing.JRadioButton();
        jLabelCopy = new javax.swing.JLabel();
        jCheckBoxShowWarning = new javax.swing.JCheckBox();
        jCheckBoxShowWelcom = new javax.swing.JCheckBox();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setName("Form"); // NOI18N
        setResizable(false);

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(app.EMPApp.class).getContext().getResourceMap(OptionsDialog.class);
        jTextMusicDir.setText(resourceMap.getString("jTextMusicDir.text")); // NOI18N
        jTextMusicDir.setName("jTextMusicDir"); // NOI18N

        jButtonOk.setText(resourceMap.getString("jButtonOk.text")); // NOI18N
        jButtonOk.setName("jButtonOk"); // NOI18N
        jButtonOk.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonOkActionPerformed(evt);
            }
        });

        jButtonCancel.setText(resourceMap.getString("jButtonCancel.text")); // NOI18N
        jButtonCancel.setName("jButtonCancel"); // NOI18N
        jButtonCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCancelActionPerformed(evt);
            }
        });

        jButtonBrowse.setText(resourceMap.getString("jButtonBrowse.text")); // NOI18N
        jButtonBrowse.setName("jButtonBrowse"); // NOI18N
        jButtonBrowse.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonBrowseActionPerformed(evt);
            }
        });

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(resourceMap.getString("jPanel1.border.title"))); // NOI18N
        jPanel1.setName("jPanel1"); // NOI18N

        jComboBoxLoad.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        jComboBoxLoad.setName("jComboBoxLoad"); // NOI18N

        jComboBoxSave.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        jComboBoxSave.setName("jComboBoxSave"); // NOI18N

        jLabel2.setText(resourceMap.getString("jLabel2.text")); // NOI18N
        jLabel2.setName("jLabel2"); // NOI18N

        jLabel3.setText(resourceMap.getString("jLabel3.text")); // NOI18N
        jLabel3.setName("jLabel3"); // NOI18N

        jLabel4.setText(resourceMap.getString("jLabel4.text")); // NOI18N
        jLabel4.setToolTipText(resourceMap.getString("jLabel4.toolTipText")); // NOI18N
        jLabel4.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        jLabel4.setName("jLabel4"); // NOI18N

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 93, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 105, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jComboBoxSave, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jComboBoxLoad, 0, 190, Short.MAX_VALUE)))
                    .addComponent(jLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, 442, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(104, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addComponent(jLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, 70, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(17, 17, 17)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(jComboBoxLoad, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(jComboBoxSave, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(21, Short.MAX_VALUE))
        );

        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setName("jLabel1"); // NOI18N

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(resourceMap.getString("jPanel2.border.title"))); // NOI18N
        jPanel2.setName("jPanel2"); // NOI18N

        jCheckBoxDublicate.setText(resourceMap.getString("jCheckBoxDublicate.text")); // NOI18N
        jCheckBoxDublicate.setName("jCheckBoxDublicate"); // NOI18N
        jCheckBoxDublicate.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxDublicateActionPerformed(evt);
            }
        });

        jRadioButtonCopy.setText(resourceMap.getString("jRadioButtonCopy.text")); // NOI18N
        jRadioButtonCopy.setName("jRadioButtonCopy"); // NOI18N
        jRadioButtonCopy.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonCopyActionPerformed(evt);
            }
        });

        jRadioButtonLink.setSelected(true);
        jRadioButtonLink.setText(resourceMap.getString("jRadioButtonLink.text")); // NOI18N
        jRadioButtonLink.setName("jRadioButtonLink"); // NOI18N
        jRadioButtonLink.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonLinkActionPerformed(evt);
            }
        });

        jLabelCopy.setText(resourceMap.getString("jLabelCopy.text")); // NOI18N
        jLabelCopy.setName("jLabelCopy"); // NOI18N

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jCheckBoxDublicate)
                    .addComponent(jRadioButtonLink)
                    .addComponent(jRadioButtonCopy)
                    .addComponent(jLabelCopy, javax.swing.GroupLayout.PREFERRED_SIZE, 464, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(82, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jCheckBoxDublicate)
                .addGap(12, 12, 12)
                .addComponent(jLabelCopy, javax.swing.GroupLayout.DEFAULT_SIZE, 18, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jRadioButtonCopy)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jRadioButtonLink)
                .addContainerGap())
        );

        jCheckBoxShowWarning.setText(resourceMap.getString("jCheckBoxShowWarning.text")); // NOI18N
        jCheckBoxShowWarning.setName("jCheckBoxShowWarning"); // NOI18N
        jCheckBoxShowWarning.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxShowWarningActionPerformed(evt);
            }
        });

        jCheckBoxShowWelcom.setText(resourceMap.getString("jCheckBoxShowWelcom.text")); // NOI18N
        jCheckBoxShowWelcom.setName("jCheckBoxShowWelcom"); // NOI18N
        jCheckBoxShowWelcom.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxShowWelcomActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jCheckBoxShowWarning)
                        .addGap(69, 69, 69)
                        .addComponent(jCheckBoxShowWelcom))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addGap(18, 18, 18)
                        .addComponent(jTextMusicDir, javax.swing.GroupLayout.DEFAULT_SIZE, 398, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jButtonBrowse))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jButtonOk)
                        .addGap(6, 6, 6)
                        .addComponent(jButtonCancel))
                    .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jButtonBrowse)
                    .addComponent(jTextMusicDir, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jCheckBoxShowWarning)
                    .addComponent(jCheckBoxShowWelcom))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 15, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButtonCancel)
                    .addComponent(jButtonOk))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    private void jButtonCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCancelActionPerformed
        this.dispose();
    }//GEN-LAST:event_jButtonCancelActionPerformed

    private void jButtonBrowseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonBrowseActionPerformed
        String dir = selectMusicDir();
        if (dir != null) {
            jTextMusicDir.setText(dir);
        }
    }//GEN-LAST:event_jButtonBrowseActionPerformed

    private void jCheckBoxDublicateActionPerformed(java.awt.event.ActionEvent evt) {
        if (jCheckBoxDublicate.isSelected()) {
            conf.setDuplicate(true);
        } else {
            conf.setDuplicate(false);
        }
    }

    private void jButtonOkActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonOkActionPerformed
        try {
            conf.setMusicDir(new File(jTextMusicDir.getText()));//GEN-LAST:event_jButtonOkActionPerformed

            /* //I hate netbeans...
            private void jCheckBoxDublicateActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxDublicateActionPerformed
            // TODO add your handling code here:
            }//GEN-LAST:event_jCheckBoxDublicateActionPerformed
            private void jRadioButtonCopyActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonCopyActionPerformed
            }//GEN-LAST:event_jRadioButtonCopyActionPerformed
            private void jRadioButtonLinkActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonLinkActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_jRadioButtonLinkActionPerformed

private void jCheckBoxShowWarningActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxShowWarningActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_jCheckBoxShowWarningActionPerformed

private void jCheckBoxShowWelcomActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxShowWelcomActionPerformed
    
}//GEN-LAST:event_jCheckBoxShowWelcomActionPerformed
            */
            conf.setLoadfrom(jComboBoxLoad.getSelectedItem().toString());
            conf.setSaveto(jComboBoxSave.getSelectedItem().toString());
            
            if (jRadioButtonLink.isSelected()) {
                conf.setCopyfiles(false);
            } else {
               conf.setCopyfiles(true);
            }
            
            EMPApp.getApplication().saveConfig((JFrame)this.getOwner());
            this.dispose();
        } catch (Exception ex) {
            Logger.getLogger(OptionsDialog.class.getName()).log(Level.SEVERE, null, ex);
            JOptionPane.showMessageDialog(this,
                                ex.getMessage() + "\nPlease select a Music folder within the WoW folder.",
                                "EpicMusicPlayer Playlist Manager", JOptionPane.WARNING_MESSAGE);
                    
        }
    }
    
    private void jCheckBoxShowWelcomActionPerformed(java.awt.event.ActionEvent evt) {
        if (jCheckBoxShowWelcom.isSelected()) {
            conf.setShowWelcomeDialog(true);
        } else {
            conf.setShowWelcomeDialog(false);
        }
    }
    
    private void jCheckBoxShowWarningActionPerformed(java.awt.event.ActionEvent evt) {
        if (jCheckBoxShowWarning.isSelected()) {
            conf.setShowWarning(true);
        } else {
            conf.setShowWarning(false);
        }
    }
    
    private void jRadioButtonCopyActionPerformed(java.awt.event.ActionEvent evt) {
        /*
        try {
            conf.setCopyfiles(true);
        } catch (Exception ex) {
            jLabelCopy.setText("Create links disabled: "+ex.getMessage());
            jRadioButtonCopy.setEnabled(false);
            jRadioButtonLink.setEnabled(false);
            jRadioButtonCopy.setSelected(true);
            Logger.getLogger(OptionsDialog.class.getName()).log(Level.SEVERE, null, ex);
        }
         */
    }
    
    private void jRadioButtonLinkActionPerformed(java.awt.event.ActionEvent evt) {
        //try {
            String message = "EpicMusicPlayer will create a link (NTFS Junction Point) " +
                    "to the original folder whenever you add a folder with music.\n" +
                    "The links will be created in the music folder and named linkto-<foldername>. \n" +
                    "Do NOT delete any files in that link or your original files will be gone. " +
                    "Just delete the link it self or the music folder if you want to remove the addon.\n" +
                    "\n" +
                    "See http://en.wikipedia.org/wiki/NTFS_junction_point for more information.\n" +
                    "\n" +
                    "You have been Warned!";
            if (!System.getProperty("os.name").equalsIgnoreCase("Windows Vista")) {
                //running xp 
                message = "EpicMusicPlayer will create a link (NTFS Junction Point) \n" +
                    "to the original folder whenever you add a folder with music.\n" +
                    "The links will be created in the music folder and named linkto-<foldername>. \n" +
                    "Do NOT delete any files in that link or your original files will be gone.\n" +
                    "\n"+
                    "WARNING: Deliting a Junction Point is not save in Windows XP.\n" +
                    "If the link (Junction Point) is sent to the recycle bin, the targeted files will look safe \n" +
                    "but will be deleted when the recycle bin is emptied.\n" +
                    "ALWAYS use shift+del to delete a link (Junction Point), the music folder or even the \n" +
                    "WoW folder as long as there are Junction Point somewhere in that folder.\n" +
                    "Or install ntfslink to make deleting Junction Points save: http://elsdoerfer.name/=ntfslink\n"+
                    "\n" +
                    "See http://en.wikipedia.org/wiki/NTFS_junction_point for more information.\n" +
                    "\n" +
                    "You have been Warned!";
            }
            
            JOptionPane.showMessageDialog(this,
                    message,
                    "EpicMusicPlayer Playlist Manager", JOptionPane.WARNING_MESSAGE);
            
            
        //    conf.setCopyfiles(false);
    /*     
        } catch (Exception ex) {
            jLabelCopy.setText("Create links disabled: "+ex.getMessage());
            jRadioButtonCopy.setEnabled(false);
            jRadioButtonLink.setEnabled(false);
            jRadioButtonCopy.setSelected(true);
            Logger.getLogger(OptionsDialog.class.getName()).log(Level.SEVERE, null, ex);
        }
     */
    }
    
    public String selectMusicDir()
    {
        //ask wow dir
            JOptionPane.showMessageDialog(this,
                    "Please select a folder for your music.\n" +
                    "The music folder can be anywhere INSIDE the WoW folder.",
                    "EpicMusicPlayer Playlist Manager", JOptionPane.INFORMATION_MESSAGE);

            boolean selectetcorrect = false;
            JFileChooser jf = null;
            //loop until user selects the correct folder, this may take a while^^
            while (!selectetcorrect) {
                jf = new JFileChooser();
                jf.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
                String path = System.getenv("ProgramFiles");
                if(path != null){
                    File currdir = new File(path);
                    jf.setCurrentDirectory(currdir);
                }
                int returnVal = jf.showOpenDialog(this);

                if (returnVal == JFileChooser.APPROVE_OPTION) {
                    try {

                        conf.setMusicDir(jf.getSelectedFile());
                        selectetcorrect = true;
                    } catch (FileNotFoundException ex) { //wrong file selected or something worse
                        Logger.getLogger(MainView.class.getName()).log(Level.SEVERE, null, ex);
                        JOptionPane.showMessageDialog(this,
                                ex.getMessage() + "\nPlease select a Music folder within the WoW folder.",
                                "EpicMusicPlayer Playlist Manager", JOptionPane.WARNING_MESSAGE);
                    }
                } else { //user clicked cancel
                    return null;
                }
            }
        return jf.getSelectedFile().getPath();
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JButton jButtonBrowse;
    private javax.swing.JButton jButtonCancel;
    private javax.swing.JButton jButtonOk;
    private javax.swing.JCheckBox jCheckBoxDublicate;
    private javax.swing.JCheckBox jCheckBoxShowWarning;
    private javax.swing.JCheckBox jCheckBoxShowWelcom;
    private javax.swing.JComboBox jComboBoxLoad;
    private javax.swing.JComboBox jComboBoxSave;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabelCopy;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JRadioButton jRadioButtonCopy;
    private javax.swing.JRadioButton jRadioButtonLink;
    private javax.swing.JTextField jTextMusicDir;
    // End of variables declaration//GEN-END:variables
    
}
