/**
 * EpicMusicPlayer Playlistgenerator
 *
 * @author yess
 */

package gui;

import playlist.Song;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.table.AbstractTableModel;


public class TableModel extends AbstractTableModel{

    private ArrayList<Song> cData;
    private String[] cCol;
    
    public TableModel(ArrayList<Song> data ){
        cData = data;
        cCol = new String[]{"Nr","Artist","Title","Album","Length","Path"};
    }
    
    public int getRowCount() {
        return cData.size();
    }

    public int getColumnCount() {
        return cCol.length;
    }

    @Override
    public String getColumnName(int columnIndex)
    {
        return cCol[columnIndex];
    }

    @Override
    public boolean isCellEditable(int rowIndex, int columnIndex){
        switch (columnIndex) {
            case 1:
                return true;    
            case 2:
                return true;
            case 3:
                return true;
            case 4:
                return true;
        } 
        return false;
    }
    
    public Object getValueAt(int rowIndex, int columnIndex) {
              
        Object o = null;
        switch (columnIndex) {
            case 0:
                o = rowIndex;
                break;
            case 1:
                o = cData.get(rowIndex).getArtist();    
                break;
            case 2:
                o = cData.get(rowIndex).getTitle();                 
                break;
            case 3:
                o = cData.get(rowIndex).getAlbum();                 
                break;
            case 4:
                o = cData.get(rowIndex).getFormatedTime();                 
                break;
            case 5:
                o = cData.get(rowIndex).getPath();                 
                break;
                
                
        }
        return o;
    }
    
    public ArrayList getList()
    {
        return cData;
    }
    
    public Song getContact(int index)
    {
        return cData.get(index);
    }
    

    
    @Override
    public void setValueAt(Object o, int rowIndex, int columnIndex) {
        switch (columnIndex) {
            case 0:
                break;
            case 1:
                cData.get(rowIndex).setArtist(o.toString());
                break;
            case 2:
                cData.get(rowIndex).setTitle(o.toString());
                break;
            case 3:
                cData.get(rowIndex).setAlbum(o.toString());
                break;
            case 4:
                String time[] = o.toString().split(":");
                int sec = 0;
                int min = 0;
                try {
                    if (time.length > 1) {
                        min = Integer.parseInt(time[0]);
                        sec = Integer.parseInt(time[1]);
                    } else {
                        sec = Integer.parseInt(time[0]);
                    }
                    int seconds = min * 60 + sec;
                    cData.get(rowIndex).setSeconds(seconds);
                } catch (NumberFormatException e) {
                    Logger.getLogger(TableModel.class.getName()).log(Level.INFO, null, e);
                }
                break;
        }
    }
    
}
